-- to do

-- isolate crash when swapping characters - probably a private event handler such as an Update

-- allow distinct modules to be enabled/disabled, including data collection - this will aid in decreasing the memory footprint as well as FPS impact for clients with limited capabilities

-- RoR mount panel - starting to think a mount panel is unnecessary

-- only update the currently displayed panel. for all other panels, update the underlying data only. this should significantly decrease load times although there will be a slight delay when first displaying certain panels

-- deed/quest panel?
-- messages arrive in the Quest channel
-- new deed message= "New Deed: deedname"
-- new quest message="New Quest: questname"
--  completed message="Completed: deedname/questname"

-- need to track bag inventory based on events. determine if all events are now firing correctly
-- reinitialize the bag inventory when the plugin loads - don't trust the saved values since there's no guarantee the player had AltInventory loaded the whole time
-- problem is ItemRemoved - it only gives the index of the backpack item, not the item name and it seems to be able to fire out of sequence when interacting with the vault
-- which makes it nearly impossible to determine whether the change was a "temporary" stack from a vault move or a real stack

-- TEST:
-- move item PASSED
-- swap item PASSED
-- merge item PASSED
-- split item PASSED
-- full combine item (should remove source stack) PASSED
-- partial combine item (should retain remainder in source stack) PASSED
-- add item - from vendor
-- add item - from vault PASSED
-- add item - from loot
-- add item - from shared storage
-- partial combine to vault - PASSED
-- remove item - destroy
-- remove item - sell
-- remove item - to vault
-- remove item - to shared storage

-- compare old qty to new qty and where delta is nil or ~=0 then trigger an update

-- bug: Equipped items display keep getting shifted around?

-- need translations for "headings color" and "list text color" captions
-- add options error message,"Adjusted Invalid Values", to strings.lua

-- overhaul Options
-- -- add a column of radio buttons for Character, Server, Account. Whichever is selected is the value that will display and will be used

-- need creep version of Stat View - attributes don't currently provide Creep data
-- remove all of the unused stat strings. remove unused stats from saved data

-- "Manual" Sort option? this would require making sure that Drag-drop operations can occur without conflict or loss...
-- need DE and FR translations for new categories
-- get improved translations for the German and French UIs

-- ItemCategory may not be properly supporting language - it gets loaded based on the client language, not the user selected language. need to check the filter and see whether this makes sense


-- turbine client imports
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
-- need localPlayer to test for session play
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
-- mmediately test for session play BEFORE importing any other files so that we can safely bail without loading any data and without any handlers
if string.sub(localPlayer:GetName(),1,1)=="~" then
	-- do not load if the character is a session play character
	Turbine.Shell.WriteLine("AltInventory no longer supports session play characters.");
	return
end

string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

import "GaranStuff.AltInventory.Class";
import "GaranStuff.AltInventory.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.AltInventory.Strings";
import "GaranStuff.AltInventory.Table";
import "GaranStuff.AltInventory.DropDownList";
import "GaranStuff.AltInventory.RadioButtonGroup";
import "GaranStuff.AltInventory.OptionsWindow";
import "GaranStuff.AltInventory.MinimizedWindow";
import "GaranStuff.AltInventory.PopUpDialog";
import "GaranStuff.AltInventory.DebugWindow";

-- set the language and locale prior to loading the panels as some of them have language/locale specific functions
language=1;
euroFormat=(tonumber("1,000")==1);
function euroNormalize(value)
	if euroFormat then
		value=tonumber((string.gsub(value,"%.",",")));
	else
		value=tonumber((string.gsub(value,",",".")));
	end
	return value
end

locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");
maxSnapShotIndex=10;

panelCount=1
inventoryPanel=panelCount;
panelCount=panelCount+1;
vaultPanel=panelCount;
panelCount=panelCount+1;
sharedStoragePanel=panelCount;
panelCount=panelCount+1;
equippedItemsPanel=panelCount;
panelCount=panelCount+1;
statisticsPanel=panelCount;
panelCount=panelCount+1;
craftingPanel=panelCount;
panelCount=panelCount+1;
notesPanel=panelCount;
panelCount=panelCount+1;
reputationPanel=panelCount;
panelCount=panelCount+1;
traitsPanel=panelCount;
panelCount=panelCount+1;
walletPanel=panelCount;
panelCount=panelCount+1;
questPanel=panelCount;
panelCount=panelCount+1;
deedPanel=panelCount;
panelCount=panelCount+1;
mountPanel=panelCount;

import "GaranStuff.AltInventory.ItemCategory";
import "GaranStuff.AltInventory.InventoryPanel";
import "GaranStuff.AltInventory.VaultPanel";
import "GaranStuff.AltInventory.SharedStoragePanel";
import "GaranStuff.AltInventory.StatsPanel";
import "GaranStuff.AltInventory.EquippedItemsPanel";
import "GaranStuff.AltInventory.CraftingPanel";
import "GaranStuff.AltInventory.NotesPanel";
import "GaranStuff.AltInventory.RepPanel";
import "GaranStuff.AltInventory.TraitsPanel";
import "GaranStuff.AltInventory.WalletPanel";
import "GaranStuff.AltInventory.TrackingWindow";
import "GaranStuff.AltInventory.CustomThresholdWindow";
import "GaranStuff.AltInventory.DeedPanel";
import "GaranStuff.AltInventory.QuestPanel";


characterListArray={};
inventoryArray={};
-- note, Race and Class are not proper enumerations (you can't iterate through them sequentially), more like flag values
--classArray elements are{turbine.class, alignment, resource string}
classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
--raceArray elements are{turbine.race, resource string} (note, alignment doesn't make sense for race since we can have evil dwarves and men)
raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]},{74,Resource[language][298]}}
--race 74=Dunedain, class 191=Ranger
colorGold=Turbine.UI.Color(.80,.60,.1);
colorSilver=Turbine.UI.Color(.75,.75,.75);
colorDarkGrey=Turbine.UI.Color(.1,.1,.1);

trimColor=Turbine.UI.Color(.2,.5,.9);
fontColor=Turbine.UI.Color(1,.9,.5);
backColor=Turbine.UI.Color(.05,.05,.05);
headingsColor=Turbine.UI.Color(1,1,1);
listTextColor=Turbine.UI.Color(1,1,1);
panelBackColor=Turbine.UI.Color(.25,.75,.45);

fontFace=Turbine.UI.Lotro.Font.TrajanPro14;
dataLoadError=false;
saveSettings=true;

currentCharIndex=1;

mainVisible=false;
minVisible=false;
iconVisible=false;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state

debug=false;

durabilitySortOrder={0,5,7,2,3,4,1,6} -- the sort values indexed by durability type ? not sure if this order is correct, especially on less than normal
qualitySortOrder={0,5,3,4,2,1} -- the sort values indexed by quality type
wearStateSortOrder={5,2,4,1,3} -- the sort values indexed by wear state type
categorySortOrder={} -- we fill this in after we load and sort the category list alphabetically
undefinedCategoryIndex=1;

-- This is the callback mechanism provided by Pengoros, slightly modified to guarantee uniqueness
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	else
		if (type(object[event]) == "table") then
			local exists=false;
			local k,v;
			for k,v in ipairs(object[event]) do
				if v==callback then
					exists=true;
					break;
				end
			end
			if not exists then
				table.insert(object[event], callback);
			end
		else
			if object[event]~=callback then
				object[event] = {object[event], callback};
			end
		end
	end
	return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function GetClassIndex(turbineClass)
	local classIndex=1;
	local tmpIndex;
	for tmpIndex=2, #classArray do
		if classArray[tmpIndex][1]==turbineClass then
			classIndex=tmpIndex;
			break;
		end
	end
	return classIndex;
end
function GetRaceIndex(turbineRace)
	local raceIndex=1;
	local tmpIndex;
	for tmpIndex=2, #raceArray do
		if raceArray[tmpIndex][1]==turbineRace then
			raceIndex=tmpIndex;
			break;
		end
	end
	return raceIndex;
end
function UnloadPlugin()
	inventoryWindow.PluginUnloading=true;
	if saveSettings then -- if there were errors loading data, the user can choose to abort saving as it would destroy their prior data
		SaveData();
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	inventoryWindow:RemoveShellCommands();

	-- disable panel updates
	for listIndex=1,#inventoryWindow.ViewPanel do
		inventoryWindow.ViewPanel[listIndex].Update=nil;
	end
	-- safely remove all callbacks
	for listIndex=1,#inventoryWindow.ViewPanel do
		if inventoryWindow.ViewPanel[listIndex].RemoveCallbacks~=nil then
			inventoryWindow.ViewPanel[listIndex]:RemoveCallbacks();
		end
	end

	RemoveCallback(localPlayer,"LevelChanged","LevelChanged")
	RemoveCallback(localPlayer,"BaseMaxMoraleChanged","BaseMaxMoraleChanged")
	RemoveCallback(localPlayer,"BaseMaxPowerChanged","BaseMaxPowerChanged")


--	Turbine.Shell.WriteLine("AltInventory "..Plugins["AltInventory"]:GetVersion()..Resource[language][250]);
	-- reenable the built in bags
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, true );
end
function GetAttributes(charIndex)
	if charIndex==nil then charIndex=currentCharIndex end
	if localPlayer:GetAlignment()==1 then
		local attributes=localPlayer:GetAttributes();
		-- money
		characterListArray[charIndex][11]=attributes:GetMoney();
		-- stats
		characterListArray[charIndex][12]=attributes:GetAcidMitigation();
		characterListArray[charIndex][13]=attributes:GetAgility();
		characterListArray[charIndex][14]=attributes:GetArmor();
		characterListArray[charIndex][15]=attributes:GetBaseAgility();
		characterListArray[charIndex][16]=attributes:GetBaseCriticalHitAvoidance();
		characterListArray[charIndex][17]=attributes:GetBaseCriticalHitChance();
		characterListArray[charIndex][18]=attributes:GetBaseFate();
		characterListArray[charIndex][19]=attributes:GetBaseMight();
		characterListArray[charIndex][20]=attributes:GetBaseResistance();
		characterListArray[charIndex][21]=attributes:GetBaseVitality();
		characterListArray[charIndex][22]=attributes:GetBaseWill();
		characterListArray[charIndex][23]=attributes:GetBlock();
		characterListArray[charIndex][24]=attributes:GetCommonMitigation();
		characterListArray[charIndex][25]=attributes:GetDiseaseResistance();
		characterListArray[charIndex][26]=attributes:GetEvade();
		characterListArray[charIndex][27]=attributes:GetFate();
		characterListArray[charIndex][28]=attributes:GetFearResistance();
		characterListArray[charIndex][29]=attributes:GetFinesse();
		characterListArray[charIndex][30]=attributes:GetFireMitigation();
		characterListArray[charIndex][31]=attributes:GetFrostMitigation();
		characterListArray[charIndex][32]=attributes:GetIncomingHealing();
		characterListArray[charIndex][33]=attributes:GetLightningMitigation();
		characterListArray[charIndex][34]=attributes:GetMeleeCriticalHitAvoidance();
		characterListArray[charIndex][35]=attributes:GetMeleeCriticalHitChance();
		characterListArray[charIndex][36]=attributes:GetMeleeDamage();
		characterListArray[charIndex][37]=attributes:GetMeleeDefence();
		characterListArray[charIndex][38]=attributes:GetMight();
		characterListArray[charIndex][39]=attributes:GetOutgoingHealing();
		characterListArray[charIndex][40]=attributes:GetParry();
		characterListArray[charIndex][41]=attributes:GetPhysicalMitigation();
		characterListArray[charIndex][42]=attributes:GetPoisonResistance();
		characterListArray[charIndex][43]=attributes:GetRangeCriticalHitAvoidance();
		characterListArray[charIndex][44]=attributes:GetRangeCriticalHitChance();
		characterListArray[charIndex][45]=attributes:GetRangeDamage();
		characterListArray[charIndex][46]=attributes:GetRangeDefence();
		characterListArray[charIndex][47]=attributes:GetShadowMitigation();
		characterListArray[charIndex][48]=attributes:GetTacticalCriticalHitAvoidance();
		characterListArray[charIndex][49]=attributes:GetTacticalCriticalHitChance();
		characterListArray[charIndex][50]=attributes:GetTacticalDamage();
		characterListArray[charIndex][51]=attributes:GetTacticalDefence();
		characterListArray[charIndex][52]=attributes:GetTacticalMitigation();
		characterListArray[charIndex][53]=attributes:GetVitality();
		characterListArray[charIndex][54]=attributes:GetWill();
		characterListArray[charIndex][55]=attributes:GetWoundResistance();
	end
end
function SaveData()

	-- save the character scope settings
	local settings={};
	local tmpIndex;
	settings["version"]=Plugins["AltInventory"]:GetVersion();
	if inventoryWindow.MinimalHeader then
		settings["IWTop"]=minimalWindow:GetTop();
		settings["IWLeft"]=minimalWindow:GetLeft();
		settings["IWHeight"]=minimalWindow:GetHeight();
		settings["IWWidth"]=minimalWindow:GetWidth();
	else
		settings["IWTop"]=inventoryWindow:GetTop();
		settings["IWLeft"]=inventoryWindow:GetLeft();
		settings["IWHeight"]=inventoryWindow:GetHeight();
		settings["IWWidth"]=inventoryWindow:GetWidth();
	end
	settings["MWTop"]=minWindow:GetTop();
	settings["MWLeft"]=minWindow:GetLeft();
	settings["ITTop"]=trackWindow:GetTop();
	settings["ITLeft"]=trackWindow:GetLeft();
	settings["ITWidth"]=trackWindow:GetWidth();
	settings["ITHeight"]=trackWindow:GetHeight();
	settings["Sort"]=inventoryWindow.ViewPanel[inventoryPanel].SortList:GetValue();
	settings["VaultSort"]=inventoryWindow.ViewPanel[vaultPanel].SortList:GetValue();
	settings["SharedSort"]=inventoryWindow.ViewPanel[sharedStoragePanel].SortList:GetValue();
	settings["VaultView"]=inventoryWindow.ViewPanel[vaultPanel].View;
	settings["SharedView"]=inventoryWindow.ViewPanel[sharedStoragePanel].View;
	settings["ReplaceBags"]=inventoryWindow:GetReplaceBags();
	settings["View"]=inventoryWindow.ViewPanel[inventoryPanel].View;
	settings["ITShowIconsInList"]=trackWindow.GetShowIconsInList();
	settings["ITDefaultCharLowThreshold"]=trackWindow.GetDefaultCharLowThreshold();
	settings["ITDefaultCharCriticalThreshold"]=trackWindow.GetDefaultCharCriticalThreshold();
	settings["ITDefaultCharHighThreshold"]=trackWindow.GetDefaultCharHighThreshold();
	settings["fontColor"]=fontColor;
	settings["trimColor"]=trimColor;
	settings["backColor"]=backColor;
	settings["panelBackColor"]=panelBackColor;
	settings["headingsColor"]=headingsColor;
	settings["listTextColor"]=listTextColor;
	settings["loadMinimized"]=inventoryWindow:GetLoadMinimized();
	settings["language"]=language;
	settings["minimalHeader"]=inventoryWindow:GetMinimalHeader();
	settings["showIconWhenMinimized"]=inventoryWindow:GetShowIconWhenMinimized();
	settings["bagSeparator"]=inventoryWindow:GetBagSeparator();
	settings["maxSnapShotIndex"]=maxSnapShotIndex;
	settings["debug"]=debug;

	local tmpvb
	for tmpvb=1,#inventoryWindow.ViewPanel do
		if inventoryWindow.ViewPanel[tmpvb].SaveData~=nil then
			inventoryWindow.ViewPanel[tmpvb]:SaveData();
		end
	end

	PatchDataSave( Turbine.DataScope.Character, "AltInventorySettings", settings );

	-- save the server scope settings
	settings={};
	settings["ITDefaultAllLowThreshold"]=trackWindow.GetDefaultAllLowThreshold();
	settings["ITDefaultAllHighThreshold"]=trackWindow.GetDefaultAllHighThreshold();
	settings["ITDefaultAllCriticalThreshold"]=trackWindow.GetDefaultAllCriticalThreshold();
	settings["version"]=Plugins["AltInventory"]:GetVersion();
	PatchDataSave( Turbine.DataScope.Server, "AltInventorySettings", settings );

	-- save the tracked items data
	trackWindow:SaveData()

	-- update the characterListArray entry dynamic data for the current character
	local index;
	for index=2,#characterListArray do
		if (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index;
			characterListArray[index][2]=localPlayer:GetLevel();
			characterListArray[index][3]=localPlayer:GetMaxMorale();
			characterListArray[index][4]=localPlayer:GetMaxPower();
			GetAttributes();
			break;
		end
	end

	-- save the character list with attributes & vocation
	table.remove(characterListArray,1); -- remove the "ALL " entry
	-- add a version stamp entry
	characterListArray[#characterListArray+1]={"&version",Plugins["AltInventory"]:GetVersion()};

	PatchDataSave( Turbine.DataScope.Server, "CharacterList", characterListArray );

	-- now save the current character's inventory
	local backpackSize=localPlayer:GetBackpack():GetSize();
	local tmpInventory={{1,0,0,0,"",0}};
	local tmpItem;
	if (backpackSize~=nil) then
		local index=1;
		while (index<=backpackSize) do
			tmpItem=localPlayer:GetBackpack():GetItem(index);
			if (tmpItem~=nil)then
				if tmpItem.GetItemInfo~=nil then
					local itemInfo=tmpItem:GetItemInfo()
					tmpInventory[index]= {index,itemInfo:GetDurability(),itemInfo:GetQuality(),tmpItem:GetWearState(),itemInfo:GetName(),tmpItem:GetQuantity(),{},itemInfo:GetBackgroundImageID(),itemInfo:GetIconImageID(),itemInfo:GetQualityImageID(),itemInfo:GetShadowImageID(),itemInfo:GetUnderlayImageID(),itemInfo:GetCategory()};
				else
					tmpInventory[index]= {index,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
				end
			else
				tmpInventory[index]={index,0,0,0,"",0,{},0,0,0,0,0,0};
			end
			index=index+1;
		end
	end
	tmpInventory[#tmpInventory+1]={"version",Plugins["AltInventory"]:GetVersion()};
	PatchDataSave( Turbine.DataScope.Server, "AltInv_"..currentCharacterName, tmpInventory);

end

function LoadData()
	local index;
	local tmpInventory={};	
	characterListArray=PatchDataLoad(Turbine.DataScope.Server, "CharacterList");
	-- detect and convert old style character lists
	if characterListArray~=nil then
		-- find and remove the "&version" entry
		local charListVersion; -- if we ever need to process version specific updates to the character list this is where we would do it
		index=1;
		while index<=#characterListArray do
			if type(characterListArray[index])=="table" and characterListArray[index][1]=="&version" then
				charListVersion=characterListArray[index][2];
				table.remove(characterListArray,index);
			else
				index=index+1;
			end
		end
		if type(characterListArray[1])=="string" then
			for index=1, #characterListArray do
				characterListArray[index]={characterListArray[index],nil};
			end
		end
	end

	if characterListArray==nil then
		characterListArray={}
	else
		local tmpAttribute
		for index=1,#characterListArray do
			if characterListArray[index]~=nil then
				for tmpAttribute=3,4 do
					if characterListArray[index][tmpAttribute]~=nil then
						characterListArray[index][tmpAttribute]=euroNormalize(characterListArray[index][tmpAttribute]);
					end
				end

				for tmpAttribute=11,55 do
					if characterListArray[index][tmpAttribute]~=nil then
						characterListArray[index][tmpAttribute]=euroNormalize(characterListArray[index][tmpAttribute]);
					end
				end
			end
		end
	end

	index=1;
	local found=false;
	while ((index<=#characterListArray) and (not found)) do
		if characterListArray[index]~=nil and (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index;
			characterListArray[index][2]=localPlayer:GetLevel();
			characterListArray[index][3]=localPlayer:GetBaseMaxMorale();
			characterListArray[index][4]=localPlayer:GetBaseMaxPower();
			characterListArray[index][5]=localPlayer:GetRace();
			characterListArray[index][6]=localPlayer:GetClass();
			characterListArray[index][7]=localPlayer:GetRaceAttributes(); -- this currently seems to be a table with only an __Implementation member which is nil
			characterListArray[index][8]=localPlayer:GetClassAttributes();
			characterListArray[index][9]=localPlayer:GetAlignment(); -- 1=Freep
			-- characterListArray[index][10]=0; -- Vocation is manually entered and maintained
			GetAttributes();
			found=true;
		end
		index=index+1;
	end
	if (not found) then
		currentCharIndex=#characterListArray+1;
		characterListArray[currentCharIndex]={currentCharacterName,localPlayer:GetLevel(),localPlayer:GetBaseMaxMorale(),localPlayer:GetBaseMaxPower(),localPlayer:GetRace(),localPlayer:GetClass(),localPlayer:GetRaceAttributes(),localPlayer:GetClassAttributes(),localPlayer:GetAlignment(),0};
		GetAttributes();
	end

	table.sort(characterListArray,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end); -- sort the character list alphabetically BEFORE adding the "ALL " entry

	table.insert(characterListArray,1,{Resource[language][29].." ",nil}); -- force it to the first entry
	
	for index=2,#characterListArray do
		-- fix the Vocation
		if characterListArray[index][10]~=nil and type(characterListArray[index][10])~="number" then characterListArray[index][10]=nil end
		if (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index; -- need to reestablish the index since the sort messes it up for new chars
--*** this may not be necessary... review where the inventory is accessed and determine if 'current' inventory is always rebuilt on the fly, if so, remove this initialization
			-- build the current character's inventory on the fly
			local backpackSize=localPlayer:GetBackpack():GetSize();
			tmpInventory={};
			local tmpItem;
			if (backpackSize~=nil) then
				local invIndex=1;
				while (invIndex<=backpackSize) do
					tmpItem=localPlayer:GetBackpack():GetItem(invIndex);
					if (tmpItem~=nil)then
						if tmpItem.GetItemInfo~=nil then
							local itemInfo=tmpItem:GetItemInfo();
							tmpInventory[invIndex]= {invIndex,itemInfo:GetDurability(),itemInfo:GetQuality(),tmpItem:GetWearState(),itemInfo:GetName(),tmpItem:GetQuantity(),{},itemInfo:GetBackgroundImageID(),itemInfo:GetIconImageID(),itemInfo:GetQualityImageID(),itemInfo:GetShadowImageID(),itemInfo:GetUnderlayImageID(),itemInfo:GetCategory()};
						else
							tmpInventory[invIndex]= {invIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
						end
					else
						tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
					end
					invIndex=invIndex+1;
				end
			end
		else
			tmpInventory = PatchDataLoad( Turbine.DataScope.Server, "AltInv_"..characterListArray[index][1]);
			if tmpInventory~=nil then
				local invVersion;
				local invIndex=1;
				while invIndex<=#tmpInventory do
					if type(tmpInventory[invIndex])=="table" and tmpInventory[invIndex][1]=="version" then
						invVersion=tmpInventory[invIndex][2];
						table.remove(tmpInventory,invIndex);
					else
						invIndex=invIndex+1;
					end
				end

			-- test for ver 1.01 files and convert if found
				if (type(tmpInventory[1])=="string") then
					local tmpRecord;
					local pos1=0; -- used for backward compatability with Ver 1.01 files
					local pos2=0; -- used for backward compatability with Ver 1.01 files
					local pos3=0; -- used for backward compatability with Ver 1.01 files
					for invIndex=1,#tmpInventory do
						-- ver 1.01 data is stored as ItemCategory/ItemQuality/ItemText/ItemQuantity
						tmpRecord=tmpInventory[invIndex];
						tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
						pos1=string.find (tmpRecord,"/",0,true);
						if (pos1~=nil)then
							pos2=string.find (tmpRecord,"/",pos1+1,true);
							if (pos2~=nil)then
								pos3=string.find (tmpRecord,"/",pos2+1,true);
								if (pos3~=nil)then
									tmpInventory[invIndex][13]=tonumber(string.sub(tmpRecord,1, pos1-1));
									tmpInventory[invIndex][3]=tonumber(string.sub(tmpRecord,pos1+1, pos2-1));
									tmpInventory[invIndex][4]=0
									tmpInventory[invIndex][5]=string.sub(tmpRecord,pos2+1, pos3-1);
									tmpInventory[invIndex][6]=tonumber(string.sub(tmpRecord,pos3+1));
									if tmpInventory[invIndex][6]==0 then tmpInventory[invIndex][6]=1 end; -- non-stacking items have a quantity of 0 for some weird reason
								end
							end
						end
					end
				end
			else
				tmpInventory={};
			end
		end
		inventoryArray[index]={};
		local tmpIndex;
		for tmpIndex=1,#tmpInventory do
			inventoryArray[index][tmpIndex]=tmpInventory[tmpIndex];
		end
		-- load ver 2.09 and prior data into the ver 2.10 table
		if BagData[characterListArray[index][1]]==nil then
			BagData[characterListArray[index][1]]=Table.Copy(tmpInventory)
			local filled=0;
			for tmpFillIndex=1,#tmpInventory do
				if tmpInventory[tmpFillIndex][5]~=nil and tmpInventory[tmpFillIndex][5]~="" then filled=filled+1 end
			end
			BagData[characterListArray[index][1]].Filled=filled;
			BagData[characterListArray[index][1]].Capacity=#tmpInventory;
		end
	end
end

function InitSelections()
	local tmpIndex;
	-- populate the character list
	characterListArray[1][1]=Resource[language][29].." "; -- account for non-default language for "ALL "
	for tmpIndex = 1, #characterListArray do
		inventoryWindow.CharacterList:AddItem( characterListArray[tmpIndex][1],tmpIndex );
	end


	-- set the default selection list selected values.
	for tmpIndex=1,#characterListArray do
		if characterListArray[tmpIndex][1]==currentCharacterName then
			inventoryWindow.CharacterList:SetSelectedIndex(tmpIndex);
			inventoryWindow.CharacterList.SelectedIndexChanged(); -- force a refresh on the character info
		end
	end

	for tmpIndex=1,inventoryWindow.ViewPanel[inventoryPanel].SortList.ListData:GetItemCount() do
		if inventoryWindow.DefaultBagSort==inventoryWindow.ViewPanel[inventoryPanel].SortList.ListData:GetItem(tmpIndex).DataValue then
			inventoryWindow.ViewPanel[inventoryPanel].SortList:SetSelectedIndex(tmpIndex);
		end
	end
	for tmpIndex=1,inventoryWindow.ViewPanel[vaultPanel].SortList.ListData:GetItemCount() do
		if inventoryWindow.DefaultVaultSort==inventoryWindow.ViewPanel[vaultPanel].SortList.ListData:GetItem(tmpIndex).DataValue then
			inventoryWindow.ViewPanel[vaultPanel].SortList:SetSelectedIndex(tmpIndex);
		end
	end
	for tmpIndex=1,inventoryWindow.ViewPanel[sharedStoragePanel].SortList.ListData:GetItemCount() do
		if inventoryWindow.DefaultSharedSort==inventoryWindow.ViewPanel[sharedStoragePanel].SortList.ListData:GetItem(tmpIndex).DataValue then
			inventoryWindow.ViewPanel[sharedStoragePanel].SortList:SetSelectedIndex(tmpIndex);
		end
	end
end

function RemoveCharacter(characterName)
	-- this function is used to remove character info for characters that have been deleted or changed servers or that you just don't want to see anymore
	-- not allowed for the current character
	if characterName~=currentCharacterName then
		local index=1;
		local found=false;
		trackWindow:RemoveCharacter(characterName);
		for index=1,#inventoryWindow.ViewPanel do
			if inventoryWindow.ViewPanel[index].RemoveCharacter~=nil then
				inventoryWindow.ViewPanel[index].RemoveCharacter(characterName);
			end
		end
		while not found and index<=#characterListArray do
			if characterListArray[index][1]==characterName then
				found=true;
				table.remove(inventoryArray[index]);
				-- no need to remove from "all" inventory since it's recalculated on the fly before displaying each time
				if index<currentCharIndex then
					currentCharIndex=currentCharIndex-1;
				end
				table.remove(characterListArray,index);
				local charIndex;
				for charIndex=1,inventoryWindow.CharacterList.ListData:GetItemCount() do
					local tmpItem=inventoryWindow.CharacterList.ListData:GetItem(charIndex);
					if tmpItem.DataValue>index then tmpItem.DataValue=tmpItem.DataValue-1 end
				end
				inventoryWindow.CharacterList:RemoveItemAt(index);
				-- fix the "values" for the CharacterList entries
				break;
			else
				index=index+1;
			end
		end
	end
end

AltInvWindow = class( Turbine.UI.Lotro.Window );
MinInvWindow = class( Turbine.UI.Window );
function MinInvWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetText("");
	self:SetSize(400,400); -- completely bogus just to get a start
	self:SetBackColor(Turbine.UI.Color(0,0,0));
	self.MenuBar=Turbine.UI.Control()
	self.MenuBar:SetParent(self);
	self.MenuBar:SetPosition(0,2);
	self.MenuBar:SetSize(244,20);
	self.MenuBar.OptMenu=Turbine.UI.Label();
	self.MenuBar.OptMenu:SetParent(self.MenuBar);
	self.MenuBar.OptMenu:SetPosition(1,-4);
	self.MenuBar.OptMenu:SetSize(80,19);
	self.MenuBar.OptMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.OptMenu:SetText(Resource[language][49]);
	self.MenuBar.OptMenu:SetBackground(0x410fd9f6);
	self.MenuBar.OptMenu.MouseEnter=function()
		self.MenuBar.OptMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.OptMenu.MouseLeave=function()
		self.MenuBar.OptMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.OptMenu.MouseClick=function()
		inventoryWindow.OptionsButton:MouseClick()
	end
	self.MenuBar.TrackMenu=Turbine.UI.Label();
	self.MenuBar.TrackMenu:SetParent(self.MenuBar);
	self.MenuBar.TrackMenu:SetPosition(82,-4);
	self.MenuBar.TrackMenu:SetSize(80,19);
	self.MenuBar.TrackMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.TrackMenu:SetText(Resource[language][50]);
	self.MenuBar.TrackMenu:SetBackground(0x410fd9f6);
	self.MenuBar.TrackMenu.MouseEnter=function()
		self.MenuBar.TrackMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.TrackMenu.MouseLeave=function()
		self.MenuBar.TrackMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.TrackMenu.MouseClick=function()
		inventoryWindow.TrackingButton:MouseClick()
	end
	self.MenuBar.PanelMenu=Turbine.UI.Label();
	self.MenuBar.PanelMenu:SetParent(self.MenuBar);
	self.MenuBar.PanelMenu:SetPosition(164,-4);
	self.MenuBar.PanelMenu:SetSize(80,19);
	self.MenuBar.PanelMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.PanelMenu:SetText(Resource[language][54]);
	self.MenuBar.PanelMenu:SetBackground(0x410fd9f6);
	self.MenuBar.PanelMenu.MouseEnter=function()
		self.MenuBar.PanelMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.PanelMenu.MouseLeave=function()
		self.MenuBar.PanelMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.PanelMenu.MouseClick=function()
		self.DisplayMenu:ShowMenu();
	end
	self.DisplayMenu=Turbine.UI.ContextMenu()
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][51]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][52]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][343]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][344]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][53]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][323]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][333]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][335]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][336]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][341]));
	self.DisplayMenu:GetItems():Get(1).Click=function()
		inventoryWindow.ViewButton[equippedItemsPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(2).Click=function()
		inventoryWindow.ViewButton[inventoryPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(3).Click=function()
		inventoryWindow.ViewButton[vaultPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(4).Click=function()
		inventoryWindow.ViewButton[sharedStoragePanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(5).Click=function()
		inventoryWindow.ViewButton[statisticsPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(6).Click=function()
		inventoryWindow.ViewButton[craftingPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(7).Click=function()
		inventoryWindow.ViewButton[notesPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(8).Click=function()
		inventoryWindow.ViewButton[reputationPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(9).Click=function()
		inventoryWindow.ViewButton[traitsPanel]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(10).Click=function()
		inventoryWindow.ViewButton[walletPanel]:MouseClick();
	end
	
	self.MenuBar.CloseMenu=Turbine.UI.Label();
	self.MenuBar.CloseMenu:SetParent(self);
	self.MenuBar.CloseMenu:SetPosition(self:GetWidth()-15,-4);
	self.MenuBar.CloseMenu:SetSize(15,19);
	self.MenuBar.CloseMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.CloseMenu:SetText("X");
	self.MenuBar.CloseMenu:SetBackground(0x410fd9f6);
	self.MenuBar.CloseMenu.MouseEnter=function()
		self.MenuBar.CloseMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.CloseMenu.MouseLeave=function()
		self.MenuBar.CloseMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.CloseMenu.MouseClick=function()
		self:SetVisible(false);
		inventoryWindow:VisibleChanged();
	end

	self.SizeChanged=function()
		local width,height=self:GetSize();
		if height<153 then
			self:SetHeight(153);
		elseif width<414 then
			self:SetWidth(414);
		else
			if inventoryWindow.MinimalHeader then
				if inventoryWindow.PanelShowing~=nil then
					inventoryWindow.ViewPanel[inventoryWindow.PanelShowing]:SetSize(width,height-43);
				end
			end
			inventoryWindow.InvalidPanel:SetSize(width,height-43);
			self.MenuBar.CloseMenu:SetLeft(width-15);
			inventoryWindow.CharacterList:SetSize(self:GetWidth()-(inventoryWindow.SelCaption:GetWidth()+inventoryWindow.SelCaption:GetLeft())-65,inventoryWindow.CharacterList:GetHeight());
			inventoryWindow.RemoveCharButton:SetLeft(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+12);
			inventoryWindow.BottomPanelTiled:SetWidth(inventoryWindow:GetWidth()-20);
			inventoryWindow.BottomPanelCenter:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.BottomPanelCenter:GetWidth())/2+1);
			inventoryWindow.BottomPanelRight:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRight:GetWidth()-4);
		end
	end
--	self:SetResizable(true); -- only available on Turbine.UI.Lotro.Window :(
	self.Sizing=false;
	self.Moving=false;
	self.MoveX=-1;
	self.MoveY=-1;
	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetBackground(0x410081c0)
	self.MovingIcon:SetStretchMode(2);
	-- for some reason, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetVisible(false);
	self.MouseDown=function(sender,args)
		if (args.Y>self:GetHeight()-15) and (args.X>self:GetWidth()-15) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x41007e20)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y>self:GetHeight()-12) then
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-22);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x410081c0)
			self.MovingIcon:SetVisible(true);
		elseif (args.X>self:GetWidth()-12) then
			self.MoveX=args.X;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-22);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x410081bf)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y<16) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x410000dd)
			self.MovingIcon:SetVisible(true);
		else
			self.MoveX=-1;
			self.MoveY=-1;
		end
	end

	self.MouseMove=function(sender,args)
		if (self.MoveY>-1 and self.MoveY<16) then
			if (args.X~=self.MoveX or args.Y~= self.MoveY) then
				self.Moving=true;
				local newLeft=self:GetLeft()-(self.MoveX-args.X)
				local newTop=self:GetTop()-(self.MoveY-args.Y)
				if newLeft<0 then newLeft=0 end;
				if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
				if newTop<0 then newTop=0 end;
				if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
				self:SetPosition(newLeft,newTop);
			end
		else		
			if (self.MoveY>-1) then
				if args.Y~= self.MoveY then
					self.Sizing=true;
					local newHeight=self:GetHeight()-(self.MoveY-args.Y);
					if newHeight<156 then newHeight=156 end;
					if newHeight>(Turbine.UI.Display.GetHeight()-self:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-self:GetTop() end;
					local newX=args.X-22;
					if newX<-13 then newX=-13 end
					if newX>(self:GetWidth()-18) then newX=self:GetWidth()-18 end
					self.MovingIcon:SetLeft(newX);
					self:SetHeight(newHeight);
					self.MoveY=args.Y;
					self.MovingIcon:SetLeft(args.X-12);
					self.MovingIcon:SetTop(args.Y-22);
				end
			end
			if (self.MoveX>-1) then
				if args.X~= self.MoveX then
					self.Sizing=true;
					local newWidth=self:GetWidth()-(self.MoveX-args.X);
					if newWidth<416 then newWidth=416 end;
					if newWidth>(Turbine.UI.Display.GetWidth()-self:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-self:GetLeft() end;
					local newY=args.Y-22;
					if newY<-13 then newY=-13 end
					if newY>(self:GetHeight()-18) then newY=self:GetHeight()-18 end
					self.MovingIcon:SetTop(newY);
					self:SetWidth(newWidth);
					self.MoveX=args.X;
					self.MovingIcon:SetLeft(args.X-12);
					self.MovingIcon:SetTop(args.Y-22);
				end
			end
		end
	end
	self.MouseUp=function(sender,args)
		if self.Sizing then
			local width,height=self:GetSize();
			local panelIndex;
			for panelIndex=1,#inventoryWindow.ViewPanel do
				inventoryWindow.ViewPanel[panelIndex]:SetSize(width,height-43);
			end
			self.Sizing=false;
		end
		self.MovingIcon:SetVisible(false);
		self.Moving=false;
		self.MoveX=-1;
		self.MoveY=-1;
	end
end

function AltInvWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetSize(414,480);
	self.Loaded=false;
	-- load the settings and set the window position if possible, otherwise default to center
	local initHeight=480;
	local initWidth=414;
	local initLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2;
	local initTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2;
	local tmpSettings={};
	local index;
	local equippedItemsIconPos=nil;
	local tmpIndex;
	local mannequinLeft=152;
	local mannequinTop=42;

	self.ReplaceBags=false;
	self.BagView=2;
	self.VaultView=2;
	self.SharedView=2;
	self.NeedsRefresh=false;
	self.PluginUnloading=false;
	self.DefaultBagSort=0;
	self.DefaultVaultSort=1;
	self.DefaultSharedSort=1;
	self.MoveX=-1;
	self.MoveY=-1;
	self.LoadMinimized=false;
	self.Filled=0;
	self.Capacity=0;
	self.MinimalHeader=false;
	self.BagSeparator=false;
	self.ShowIconWhenMinimized=true;

	self.PanelShowing=1;

	tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "AltInventorySettings");
	if (tmpSettings~=nil) then
		if tostring(type(tmpSettings))=="table" then
			if tmpSettings["version"]==nil then
				for index=1,#tmpSettings do
					if tostring(type(tmpSettings[index]))=="table" then
						if (tmpSettings[index][1]=="IWTop") then
							initTop=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="IWLeft") then
							initLeft=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="IWHeight") then
							initHeight=euroNormalize(tmpSettings[index][2]);
						elseif (tmpSettings[index][1]=="IWWidth") then
							initWidth=euroNormalize(tmpSettings[index][2]);
						elseif (tmpSettings[index][1]=="Sort") then
							self.DefaultBagSort=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="VaultSort") then
							self.DefaultVaultSort=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="SharedSort") then
							self.DefaultSharedSort=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="View") then
							self.BagView=tmpSettings[index][2];
							if self.BagView==0 then self.BagView=2 end; -- account for old bagView settings
						elseif (tmpSettings[index][1]=="VaultView") then
							self.VaultView=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="SharedView") then
							self.SharedView=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="trimColor") then
							trimColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="fontColor") then
							fontColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="backColor") then
							backColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="panelBackColor") then
							panelBackColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="headingsColor") then
							headingsColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="listTextColor") then
							listTextColor=Turbine.UI.Color(euroNormalize(tmpSettings[index][2].R),euroNormalize(tmpSettings[index][2].G),euroNormalize(tmpSettings[index][2].B));
						elseif (tmpSettings[index][1]=="ReplaceBags") then
							self.ReplaceBags=tmpSettings[index][2];
							if self.ReplaceBags then
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );
								Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, false );
							end
						elseif (tmpSettings[index][1]=="loadMinimized") then
							self.LoadMinimized=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="language") then
							if tonumber(tmpSettings[index][2])~=nil then
								language=tonumber(tmpSettings[index][2]);
							end
							classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
							raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]},{74,Resource[language][298]}}
						elseif (tmpSettings[index][1]=="minimalHeader") then
							self.MinimalHeader=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="bagSeparator") then
							self.BagSeparator=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="showIconWhenMinimized") then
							self.ShowIconWhenMinimized=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="EquippedItemsIconPos") then
							equippedItemsIconPos=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="MannequinPos") then
							mannequinLeft=tmpSettings[index][2][1];
							mannequinTop=tmpSettings[index][2][2];
						elseif (tmpSettings[index][1]=="maxSnapShotIndex") then
							maxSnapShotIndex=tmpSettings[index][2];
						elseif (tmpSettings[index][1]=="debug") then
							debug=tmpSettings[index][2];
						end
					end
				end
			else
				if tmpSettings["IWTop"]~=nil then initTop=tmpSettings["IWTop"] end
				if tmpSettings["IWLeft"]~=nil then initLeft=tmpSettings["IWLeft"] end
				if tmpSettings["IWHeight"]~=nil then initHeight=euroNormalize(tmpSettings["IWHeight"]) end
				if tmpSettings["IWWidth"]~=nil then initWidth=euroNormalize(tmpSettings["IWWidth"]) end
				if tmpSettings["Sort"]~=nil then self.DefaultBagSort=tmpSettings["Sort"] end
				if tmpSettings["VaultSort"]~=nil then self.DefaultVaultSort=tmpSettings["VaultSort"] end
				if tmpSettings["SharedSort"]~=nil then self.DefaultSharedSort=tmpSettings["SharedSort"] end
				if tmpSettings["View"]~= nil then
					self.BagView=tmpSettings["View"];
					if self.BagView==0 then self.BagView=2 end; -- account for old bagView settings
				end
				if tmpSettings["VaultView"]~=nil then self.VaultView=tmpSettings["VaultView"] end
				if tmpSettings["SharedView"]~=nil then self.SharedView=tmpSettings["SharedView"] end
				if tmpSettings["trimColor"]~=nil then trimColor=Turbine.UI.Color(euroNormalize(tmpSettings["trimColor"].R),euroNormalize(tmpSettings["trimColor"].G),euroNormalize(tmpSettings["trimColor"].B)) end
				if tmpSettings["fontColor"]~=nil then fontColor=Turbine.UI.Color(euroNormalize(tmpSettings["fontColor"].R),euroNormalize(tmpSettings["fontColor"].G),euroNormalize(tmpSettings["fontColor"].B)) end
				if tmpSettings["backColor"]~=nil then backColor=Turbine.UI.Color(euroNormalize(tmpSettings["backColor"].R),euroNormalize(tmpSettings["backColor"].G),euroNormalize(tmpSettings["backColor"].B)) end
				if tmpSettings["panelBackColor"]~=nil then panelBackColor=Turbine.UI.Color(euroNormalize(tmpSettings["panelBackColor"].R),euroNormalize(tmpSettings["panelBackColor"].G),euroNormalize(tmpSettings["panelBackColor"].B)) end
				if tmpSettings["headingsColor"]~=nil then headingsColor=Turbine.UI.Color(euroNormalize(tmpSettings["headingsColor"].R),euroNormalize(tmpSettings["headingsColor"].G),euroNormalize(tmpSettings["headingsColor"].B)) end
				if tmpSettings["listTextColor"]~=nil then listTextColor=Turbine.UI.Color(euroNormalize(tmpSettings["listTextColor"].R),euroNormalize(tmpSettings["listTextColor"].G),euroNormalize(tmpSettings["listTextColor"].B)) end
				if tmpSettings["ReplaceBags"]~=nil then
					self.ReplaceBags=tmpSettings["ReplaceBags"];
					if self.ReplaceBags then
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );
						Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, false );
					end
				end
				if tmpSettings["loadMinimized"]~=nil then self.LoadMinimized=tmpSettings["loadMinimized"] end
				if tmpSettings["language"]~=nil and tonumber(tmpSettings["language"])~=nil then
					language=tonumber(tmpSettings["language"])
					classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
					raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]},{74,Resource[language][298]}}
				end
				if tmpSettings["minimalHeader"]~=nil then self.MinimalHeader=tmpSettings["minimalHeader"] end
				if tmpSettings["bagSeparator"]~=nil then self.BagSeparator=tmpSettings["bagSeparator"] end
				if tmpSettings["showIconWhenMinimized"]~=nil then self.ShowIconWhenMinimized=tmpSettings["showIconWhenMinimized"] end
				if tmpSettings["EquippedItemsIconPos"]~=nil then equippedItemsIconPos=tmpSettings["EquippedItemsIconPos"] end
				if tmpSettings["MannequinPos"]~=nil then
					mannequinLeft=tmpSettings["MannequinPos"][1];
					mannequinTop=tmpSettings["MannequinPos"][2];
				end
				if tmpSettings["maxSnapShotIndex"]~=nil then maxSnapShotIndex=tmpSettings["maxSnapShotIndex"] end
				if tmpSettings["debug"]~=nil then debug=tmpSettings["debug"] end
			end
		else
			-- data was unreadable, we need to display a message to the user that the data could not be read
			dataLoadError=true
		end
		-- account for changed resolution
		if initWidth>Turbine.UI.Display:GetWidth() then initWidth=Turbine.UI.Display:GetWidth() end
		if initHeight>Turbine.UI.Display:GetHeight() then initHeight=Turbine.UI.Display:GetHeight() end
		if initLeft>(Turbine.UI.Display.GetWidth()-initWidth) then initLeft=Turbine.UI.Display.GetWidth()-initWidth end;
		if initLeft<0 then initLeft=0 end;
		if initWidth>(Turbine.UI.Display.GetWidth()-initLeft) then initWidth=Turbine.UI.Display.GetWidth()-initLeft end;
		if initTop>(Turbine.UI.Display.GetHeight()-initHeight) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
		if initTop<0 then initTop=0 end;
		if initHeight>(Turbine.UI.Display.GetHeight()-initTop) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
	end

	self.playerAttributes=localPlayer:GetAttributes();

	self:SetPosition( initLeft, initTop );
	self:SetHeight(initHeight);
	self:SetWidth(initWidth);
	self:SetOpacity( 1 );
	self:SetVisible(false);

	self.TitleIcon=Turbine.UI.Control();
	self.TitleIcon:SetParent(self);
	self.TitleIcon:SetSize(30,25);
	if language==1 then
		self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
	elseif language==2 then
		self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
	else
		self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
	end
	self.TitleIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TitleIcon:SetBackground("GaranStuff/AltInventory/Resources/title_icon.tga");
	self.TitleIcon:SetMouseVisible(false);

	-- now that we allow resizing width like the Turbine Vault window, we have to have multiple panels in the top and bottom that can seperate the way the turbine ones do..
	self.TopPanelTiled=Turbine.UI.Control();
	self.TopPanelTiled:SetParent(self);
	self.TopPanelTiled:SetZOrder(self:GetZOrder()-1);
	self.TopPanelTiled:SetSize(self:GetWidth()-30,111); --115
	self.TopPanelTiled:SetPosition(6,29);
	self.TopPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_toptiled_bw.jpg");
	self.TopPanelTiled:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.TopPanelTiled:SetBackColor(panelBackColor);
	self.TopPanelTiled:SetMouseVisible(false);

	self.TopPanelTiledTrim=Turbine.UI.Control();
	self.TopPanelTiledTrim:SetParent(self);
	self.TopPanelTiledTrim:SetZOrder(self:GetZOrder()-1);
	self.TopPanelTiledTrim:SetSize(self:GetWidth()-30,4); --115
	self.TopPanelTiledTrim:SetPosition(6,136);
	self.TopPanelTiledTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelTiledTrim:SetBackground("GaranStuff/AltInventory/Resources/background_toptiled_trim.jpg");
	self.TopPanelTiledTrim:SetMouseVisible(false);

	self.TopPanelLeft=Turbine.UI.Control();
	self.TopPanelLeft:SetParent(self);
	self.TopPanelLeft:SetZOrder(self:GetZOrder()-1);
	self.TopPanelLeft:SetSize(86,118);
	self.TopPanelLeft:SetPosition(5,22);
	self.TopPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_top_left.tga");
	self.TopPanelLeft:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.TopPanelLeft:SetBackColor(panelBackColor);
	self.TopPanelLeft:SetMouseVisible(false);

	self.TopPanelLeftTrim=Turbine.UI.Control();
	self.TopPanelLeftTrim:SetParent(self);
	self.TopPanelLeftTrim:SetZOrder(self:GetZOrder()-1);
	self.TopPanelLeftTrim:SetSize(86,118);
	self.TopPanelLeftTrim:SetPosition(5,22);
	self.TopPanelLeftTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelLeftTrim:SetBackground("GaranStuff/AltInventory/Resources/background_top_left_trim.tga");
	self.TopPanelLeftTrim:SetMouseVisible(false);

	self.TopPanelCenter=Turbine.UI.Control();
	self.TopPanelCenter:SetParent(self);
	self.TopPanelCenter:SetSize(382,106);
	self.TopPanelCenter:SetPosition((self:GetWidth()-self.TopPanelCenter:GetWidth())/2-3,30);
	self.TopPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_top_center.tga");
	self.TopPanelCenter:SetMouseVisible(false);

	self.TopPanelRight=Turbine.UI.Control();
	self.TopPanelRight:SetParent(self);
	self.TopPanelRight:SetZOrder(-1);
	self.TopPanelRight:SetSize(86,118);
	self.TopPanelRight:SetPosition(self:GetWidth()-self.TopPanelRight:GetWidth()-5,22);
	self.TopPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_top_right.tga");
	self.TopPanelRight:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.TopPanelRight:SetBackColor(panelBackColor);
	self.TopPanelRight:SetMouseVisible(false);

	self.TopPanelRightTrim=Turbine.UI.Control();
	self.TopPanelRightTrim:SetParent(self);
	self.TopPanelRightTrim:SetZOrder(-1);
	self.TopPanelRightTrim:SetSize(86,118);
	self.TopPanelRightTrim:SetPosition(self:GetWidth()-self.TopPanelRightTrim:GetWidth()-5,22);
	self.TopPanelRightTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelRightTrim:SetBackground("GaranStuff/AltInventory/Resources/background_top_right_trim.tga");
	self.TopPanelRightTrim:SetMouseVisible(false);

	self.CloseButton=Turbine.UI.Control();
	self.CloseButton:SetParent(self);
	self.CloseButton:SetSize(16,16);
	self.CloseButton:SetPosition(self:GetWidth()-self.CloseButton:GetWidth()-6,21);
	self.CloseButton:SetBackground(0x41000196);
	self.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.CloseButton.MouseEnter=function()
		self.CloseButton:SetBackground(0x41000198);
	end
	self.CloseButton.MouseLeave=function()
		self.CloseButton:SetBackground(0x41000196);
	end
	self.CloseButton.MouseDown=function()
		self.CloseButton:SetBackground(0x41000197);
	end
	self.CloseButton.MouseClick=function()
		self:Close();
	end

	self:SetText("      "..Resource[language][2].."      ");
	self.VisibleChanged=function()
		if (not self.PluginUnloading) then
			if (not self:IsVisible() and not minimalWindow:IsVisible()) then
				self.ViewPanel[inventoryPanel].SearchText:SetWantsUpdates(false);
				self.ViewPanel[vaultPanel].SearchText:SetWantsUpdates(false);
				self.ViewPanel[sharedStoragePanel].SearchText:SetWantsUpdates(false);
				minWindow:SetVisible(true);
				if optWindow~=nil then optWindow:SetVisible(false) end;
				if trackWindow~=nil then trackWindow:SetVisible(false) end;
			else
				if self.CharacterList:GetValue()~=nil then
					self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
				end
			end
			inventoryWindow.ViewPanel[statisticsPanel]:SetWantsUpdates(inventoryWindow.ViewPanel[statisticsPanel]:GetParent():IsVisible())
		end
	end

	self.SelCaption=Turbine.UI.Label();
	self.SelCaption:SetParent(self);
	self.SelCaption:SetPosition(15,39);
	self.SelCaption:SetSize(78,20);
	self.SelCaption:SetFont(fontFace);
	self.SelCaption:SetForeColor(fontColor);
	self.SelCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SelCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SelCaption:SetText(Resource[language][15]..":");

	self.CharacterList=DropDownList();
	self.CharacterList:SetParent(self);
	self.CharacterList:SetPosition(self.SelCaption:GetLeft()+self.SelCaption:GetWidth()+2,self.SelCaption:GetTop()-3);
	self.CharacterList:SetSize(self:GetWidth()-(self.SelCaption:GetWidth()+self.SelCaption:GetLeft())-65,20);
	self.CharacterList:SetBorderColor(trimColor);
	self.CharacterList:SetBackColor(backColor);
	self.CharacterList:SetTextColor(listTextColor);
	self.CharacterList:SetCurrentBackColor(backColor);
	self.CharacterList:SetDropRows(8);

	self.CharacterList.SelectedIndexChanged = function ()
		self.RemoveCharButton:SetVisible(self.CharacterList:GetValue()~=nil and self.CharacterList:GetValue()~=1 and characterListArray[self.CharacterList:GetValue()][1]~=currentCharacterName);
		if characterListArray[self.CharacterList:GetValue()]~=nil then
			self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
			local panelIndex
			for panelIndex=1,#self.ViewPanel do
				if self.ViewPanel[panelIndex].LoadPanelData ~= nil then
					self.ViewPanel[panelIndex]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1]);
				end
			end
		end
	end

	self.RemoveCharButton=Turbine.UI.Control();
	self.RemoveCharButton:SetParent(self);
	self.RemoveCharButton:SetPosition(self.CharacterList:GetLeft()+self.CharacterList:GetWidth()+12,self.CharacterList:GetTop());
	self.RemoveCharButton:SetSize(20,20);
	self.RemoveCharButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	self.RemoveCharButton:SetVisible(false);
	self.RemoveCharButton.MouseEnter = function()
		self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull_hover.tga");
	end
	self.RemoveCharButton.MouseLeave = function()
		self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	end
	self.RemoveCharButton.MouseClick = function()
		-- display confirmation
		self:SetEnabled(false);
		self.RemoveConfirmation:SetPosition((self.RemoveConfirmation:GetParent():GetWidth()-self.RemoveConfirmation:GetWidth())/2,(self.RemoveConfirmation:GetParent():GetHeight()-self.RemoveConfirmation:GetHeight())/2);
		self.RemoveConfirmation:SetVisible(true);
	end

	self.RemoveConfirmation=Turbine.UI.Label();
	self.RemoveConfirmation:SetParent(self);
	self.RemoveConfirmation:SetSize(200,200);
	self.RemoveConfirmation:SetPosition((self:GetWidth()-self.RemoveConfirmation:GetWidth())/2,(self:GetHeight()-self.RemoveConfirmation:GetHeight())/2);
	self.RemoveConfirmation:SetBackColor(trimColor);
	self.RemoveConfirmation.Text=Turbine.UI.Label();
	self.RemoveConfirmation.Text:SetParent(self.RemoveConfirmation)
	self.RemoveConfirmation.Text:SetSize(self.RemoveConfirmation:GetWidth()-2,self.RemoveConfirmation:GetHeight()-2);
	self.RemoveConfirmation.Text:SetPosition(1,1);
	self.RemoveConfirmation.Text:SetBackColor(backColor);
	self.RemoveConfirmation.Text:SetForeColor(fontColor);
	self.RemoveConfirmation.Text:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.RemoveConfirmation.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.RemoveConfirmation.Text:SetText("Are you sure you wish to remove this character's inventory information?");
	self.RemoveConfirmation.OK=Turbine.UI.Lotro.Button();
	self.RemoveConfirmation.OK:SetParent(self.RemoveConfirmation.Text);
	self.RemoveConfirmation.OK:SetSize(80,20);
	self.RemoveConfirmation.OK:SetPosition(10,self.RemoveConfirmation.Text:GetHeight()-25);
	self.RemoveConfirmation.OK:SetText("OK");
	self.RemoveConfirmation.OK.Click=function()
		RemoveCharacter(self.CharacterList:GetText());
		self:SetEnabled(true);
		self.RemoveConfirmation:SetVisible(false);
	end
	self.RemoveConfirmation.Cancel=Turbine.UI.Lotro.Button();
	self.RemoveConfirmation.Cancel:SetParent(self.RemoveConfirmation.Text);
	self.RemoveConfirmation.Cancel:SetSize(80,20);
	self.RemoveConfirmation.Cancel:SetPosition(self.RemoveConfirmation.Text:GetWidth()-self.RemoveConfirmation.Cancel:GetWidth()-10,self.RemoveConfirmation.Text:GetHeight()-25);
	self.RemoveConfirmation.Cancel:SetText("Cancel");
	self.RemoveConfirmation.Cancel.Click=function()
		self:SetEnabled(true);
		self.RemoveConfirmation:SetVisible(false);
	end
	self.RemoveConfirmation:SetVisible(false);

	self.BagCapacityPanel=Turbine.UI.Control();
	self.BagCapacityPanel:SetParent(self);
	self.BagCapacityPanel.MaxWidth=376;
	self.BagCapacityPanel:SetPosition((self:GetWidth()-self.BagCapacityPanel.MaxWidth)/2,65);
	self.BagCapacityPanel:SetSize(self.BagCapacityPanel.MaxWidth,17);

	self.BagCapacityPanel.Empty=Turbine.UI.Label();
	self.BagCapacityPanel.Empty:SetParent(self);
	self.BagCapacityPanel.Empty:SetPosition(self.BagCapacityPanel:GetLeft()+3,64);
	self.BagCapacityPanel.Empty:SetSize(60,20);
	self.BagCapacityPanel.Empty:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	self.BagCapacityPanel.Empty:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.BagCapacityPanel.Empty:SetForeColor(Turbine.UI.Color(0,.7,0));
	self.BagCapacityPanel.Empty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.BagCapacityPanel.Empty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.BagCapacityPanel.Empty:SetText(Resource[language][21]);

	self.BagCapacityPanel.Display=Turbine.UI.Label();
	self.BagCapacityPanel.Display:SetParent(self);
	self.BagCapacityPanel.Display:SetSize(368,20);
	self.BagCapacityPanel.Display:SetPosition((self:GetWidth()-self.BagCapacityPanel.Display:GetWidth())/2,64);
	self.BagCapacityPanel.Display:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.BagCapacityPanel.Display:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.BagCapacityPanel.Display:SetForeColor(fontColor);
	self.BagCapacityPanel.Display:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.BagCapacityPanel.Display:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.BagCapacityPanel.Display:SetText(Resource[language][22]);

	self.BagCapacityPanel.Full=Turbine.UI.Label();
	self.BagCapacityPanel.Full:SetParent(self);
	self.BagCapacityPanel.Full:SetSize(60,20);
	self.BagCapacityPanel.Full:SetPosition(self:GetWidth()-self.BagCapacityPanel.Empty:GetLeft()-66,64);
	self.BagCapacityPanel.Full:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);
	self.BagCapacityPanel.Full:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.BagCapacityPanel.Full:SetForeColor(Turbine.UI.Color(.75,0,0));
	self.BagCapacityPanel.Full:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.BagCapacityPanel.Full:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.BagCapacityPanel.Full:SetText(Resource[language][23]);


	self.SharedCapacityPanel=Turbine.UI.Control();
	self.SharedCapacityPanel:SetParent(self);
	self.SharedCapacityPanel.MaxWidth=376;
	self.SharedCapacityPanel:SetPosition((self:GetWidth()-self.SharedCapacityPanel.MaxWidth)/2,65);
	self.SharedCapacityPanel:SetSize(self.SharedCapacityPanel.MaxWidth,17);
	self.SharedCapacityPanel:SetVisible(false);

	self.SharedCapacityPanel.Empty=Turbine.UI.Label();
	self.SharedCapacityPanel.Empty:SetParent(self);
	self.SharedCapacityPanel.Empty:SetPosition(self.SharedCapacityPanel:GetLeft()+3,64);
	self.SharedCapacityPanel.Empty:SetSize(60,20);
	self.SharedCapacityPanel.Empty:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	self.SharedCapacityPanel.Empty:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SharedCapacityPanel.Empty:SetForeColor(Turbine.UI.Color(0,.7,0));
	self.SharedCapacityPanel.Empty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SharedCapacityPanel.Empty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SharedCapacityPanel.Empty:SetText(Resource[language][21]);
	self.SharedCapacityPanel.Empty:SetVisible(false);

	self.SharedCapacityPanel.Display=Turbine.UI.Label();
	self.SharedCapacityPanel.Display:SetParent(self);
	self.SharedCapacityPanel.Display:SetSize(368,20);
	self.SharedCapacityPanel.Display:SetPosition((self:GetWidth()-self.SharedCapacityPanel.Display:GetWidth())/2,64);
	self.SharedCapacityPanel.Display:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.SharedCapacityPanel.Display:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SharedCapacityPanel.Display:SetForeColor(fontColor);
	self.SharedCapacityPanel.Display:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SharedCapacityPanel.Display:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SharedCapacityPanel.Display:SetText(Resource[language][22]);
	self.SharedCapacityPanel.Display:SetVisible(false);

	self.SharedCapacityPanel.Full=Turbine.UI.Label();
	self.SharedCapacityPanel.Full:SetParent(self);
	self.SharedCapacityPanel.Full:SetSize(60,20);
	self.SharedCapacityPanel.Full:SetPosition(self:GetWidth()-self.SharedCapacityPanel.Empty:GetLeft()-66,64);
	self.SharedCapacityPanel.Full:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);
	self.SharedCapacityPanel.Full:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SharedCapacityPanel.Full:SetForeColor(Turbine.UI.Color(.75,0,0));
	self.SharedCapacityPanel.Full:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SharedCapacityPanel.Full:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SharedCapacityPanel.Full:SetText(Resource[language][23]);
	self.SharedCapacityPanel.Full:SetVisible(false);

--*******************
	self.VaultCapacityPanel=Turbine.UI.Control();
	self.VaultCapacityPanel:SetParent(self);
	self.VaultCapacityPanel.MaxWidth=376;
	self.VaultCapacityPanel:SetPosition((self:GetWidth()-self.VaultCapacityPanel.MaxWidth)/2,65);
	self.VaultCapacityPanel:SetSize(self.VaultCapacityPanel.MaxWidth,17);
	self.VaultCapacityPanel:SetVisible(false);

	self.VaultCapacityPanel.Empty=Turbine.UI.Label();
	self.VaultCapacityPanel.Empty:SetParent(self);
	self.VaultCapacityPanel.Empty:SetPosition(self.VaultCapacityPanel:GetLeft()+3,64);
	self.VaultCapacityPanel.Empty:SetSize(60,20);
	self.VaultCapacityPanel.Empty:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	self.VaultCapacityPanel.Empty:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.VaultCapacityPanel.Empty:SetForeColor(Turbine.UI.Color(0,.7,0));
	self.VaultCapacityPanel.Empty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.VaultCapacityPanel.Empty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.VaultCapacityPanel.Empty:SetText(Resource[language][21]);
	self.VaultCapacityPanel.Empty:SetVisible(false);

	self.VaultCapacityPanel.Display=Turbine.UI.Label();
	self.VaultCapacityPanel.Display:SetParent(self);
	self.VaultCapacityPanel.Display:SetSize(368,20);
	self.VaultCapacityPanel.Display:SetPosition((self:GetWidth()-self.VaultCapacityPanel.Display:GetWidth())/2,64);
	self.VaultCapacityPanel.Display:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.VaultCapacityPanel.Display:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.VaultCapacityPanel.Display:SetForeColor(fontColor);
	self.VaultCapacityPanel.Display:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.VaultCapacityPanel.Display:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.VaultCapacityPanel.Display:SetText(Resource[language][22]);
	self.VaultCapacityPanel.Display:SetVisible(false);

	self.VaultCapacityPanel.Full=Turbine.UI.Label();
	self.VaultCapacityPanel.Full:SetParent(self);
	self.VaultCapacityPanel.Full:SetSize(60,20);
	self.VaultCapacityPanel.Full:SetPosition(self:GetWidth()-self.VaultCapacityPanel.Empty:GetLeft()-66,64);
	self.VaultCapacityPanel.Full:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);
	self.VaultCapacityPanel.Full:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.VaultCapacityPanel.Full:SetForeColor(Turbine.UI.Color(.75,0,0));
	self.VaultCapacityPanel.Full:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.VaultCapacityPanel.Full:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.VaultCapacityPanel.Full:SetText(Resource[language][23]);
	self.VaultCapacityPanel.Full:SetVisible(false);

	self.ViewButton={};
	self.ViewPanel={};
	self.ViewButton[1]=Turbine.UI.Control();
	self.ViewButton[1]:SetParent(self);
	self.ViewButton[1]:SetSize(32,32);
	self.ViewButton[1]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[1]:SetBackground("GaranStuff/AltInventory/Resources/Inventory.tga");
	self.ViewButton[1].GreyIcon="GaranStuff/AltInventory/Resources/Inventory_grey.tga";
	self.ViewButton[1].Icon="GaranStuff/AltInventory/Resources/Inventory.tga";
	self.ViewButton[1].Index=1;
	self.ViewButton[1].HoverName=Resource[language][52];

	self.ViewButton[2]=Turbine.UI.Control();
	self.ViewButton[2]:SetParent(self);
	self.ViewButton[2]:SetSize(32,32);
	self.ViewButton[2]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[2]:SetBackground("GaranStuff/AltInventory/Resources/Vault_grey.tga");
	self.ViewButton[2].GreyIcon="GaranStuff/AltInventory/Resources/Vault_grey.tga";
	self.ViewButton[2].Icon="GaranStuff/AltInventory/Resources/Vault.tga";
	self.ViewButton[2].Index=2;
	self.ViewButton[2].HoverName=Resource[language][343];

	self.ViewButton[3]=Turbine.UI.Control();
	self.ViewButton[3]:SetParent(self);
	self.ViewButton[3]:SetSize(32,32);
	self.ViewButton[3]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[3]:SetBackground("GaranStuff/AltInventory/Resources/SharedStorage_grey.tga");
	self.ViewButton[3].GreyIcon="GaranStuff/AltInventory/Resources/SharedStorage_grey.tga";
	self.ViewButton[3].Icon="GaranStuff/AltInventory/Resources/SharedStorage.tga";
	self.ViewButton[3].Index=3;
	self.ViewButton[3].HoverName=Resource[language][344];

	self.ViewButton[4]=Turbine.UI.Control();
	self.ViewButton[4]:SetParent(self);
	self.ViewButton[4]:SetSize(32,32);
	self.ViewButton[4]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[4]:SetBackground("GaranStuff/AltInventory/Resources/EquippedItems_grey.tga");
	self.ViewButton[4].GreyIcon="GaranStuff/AltInventory/Resources/EquippedItems_grey.tga";
	self.ViewButton[4].Icon="GaranStuff/AltInventory/Resources/EquippedItems.tga";
	self.ViewButton[4].Index=4;
	self.ViewButton[4].HoverName=Resource[language][51];

	self.ViewButton[5]=Turbine.UI.Control();
	self.ViewButton[5]:SetParent(self);
	self.ViewButton[5]:SetSize(32,32);
	self.ViewButton[5]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[5]:SetBackground("GaranStuff/AltInventory/Resources/Statistics_grey.tga");
	self.ViewButton[5].GreyIcon="GaranStuff/AltInventory/Resources/Statistics_grey.tga";
	self.ViewButton[5].Icon="GaranStuff/AltInventory/Resources/Statistics.tga";
	self.ViewButton[5].Index=5;
	self.ViewButton[5].HoverName=Resource[language][53];

	self.ViewButton[6]=Turbine.UI.Control();
	self.ViewButton[6]:SetParent(self);
	self.ViewButton[6]:SetSize(32,32);
	self.ViewButton[6]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[6]:SetBackground("GaranStuff/AltInventory/Resources/Crafting_grey.tga");
	self.ViewButton[6].GreyIcon="GaranStuff/AltInventory/Resources/Crafting_grey.tga";
	self.ViewButton[6].Icon="GaranStuff/AltInventory/Resources/Crafting.tga";
	self.ViewButton[6].Index=6;
	self.ViewButton[6].HoverName=Resource[language][323];

	self.ViewButton[7]=Turbine.UI.Control();
	self.ViewButton[7]:SetParent(self);
	self.ViewButton[7]:SetSize(32,32);
	self.ViewButton[7]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[7]:SetBackground("GaranStuff/AltInventory/Resources/Notes_grey.tga");
	self.ViewButton[7].GreyIcon="GaranStuff/AltInventory/Resources/Notes_grey.tga";
	self.ViewButton[7].Icon="GaranStuff/AltInventory/Resources/Notes.tga";
	self.ViewButton[7].Index=7;
	self.ViewButton[7].HoverName=Resource[language][333];

	self.ViewButton[8]=Turbine.UI.Control();
	self.ViewButton[8]:SetParent(self);
	self.ViewButton[8]:SetSize(32,32);
	self.ViewButton[8]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[8]:SetBackground("GaranStuff/AltInventory/Resources/Reputation_grey.tga");
	self.ViewButton[8].GreyIcon="GaranStuff/AltInventory/Resources/Reputation_grey.tga";
	self.ViewButton[8].Icon="GaranStuff/AltInventory/Resources/Reputation.tga";
	self.ViewButton[8].Index=8;
	self.ViewButton[8].HoverName=Resource[language][335];

	self.ViewButton[9]=Turbine.UI.Control();
	self.ViewButton[9]:SetParent(self);
	self.ViewButton[9]:SetSize(32,32);
	self.ViewButton[9]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[9]:SetBackground("GaranStuff/AltInventory/Resources/Pennon_grey.tga");
	self.ViewButton[9].GreyIcon="GaranStuff/AltInventory/Resources/Pennon_grey.tga";
	self.ViewButton[9].Icon="GaranStuff/AltInventory/Resources/Pennon.tga";
	self.ViewButton[9].Index=9;
	self.ViewButton[9].HoverName=Resource[language][336];

	self.ViewButton[10]=Turbine.UI.Control();
	self.ViewButton[10]:SetParent(self);
	self.ViewButton[10]:SetSize(32,32);
	self.ViewButton[10]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[10]:SetBackground("GaranStuff/AltInventory/Resources/Wallet_grey.tga");
	self.ViewButton[10].GreyIcon="GaranStuff/AltInventory/Resources/Wallet_grey.tga";
	self.ViewButton[10].Icon="GaranStuff/AltInventory/Resources/Wallet.tga";
	self.ViewButton[10].Index=10;
	self.ViewButton[10].HoverName=Resource[language][341];

	self.ViewButtonMenu=Turbine.UI.ContextMenu()
	self.ViewButtonMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][52]));

	local vbleft=(self:GetWidth()-32*#self.ViewButton-4*(#self.ViewButton-1))/2;

	for tmpIndex=1,#self.ViewButton do
		self.ViewButton[tmpIndex]:SetPosition(vbleft+(tmpIndex-1)*36,96);
		self.ViewButton[tmpIndex].HideTimer=0;
		self.ViewButton[tmpIndex].MenuEnabled=false;
		self.ViewButton[tmpIndex].MouseEnter=function(button)
			if self.PanelShowing~=button.Index then
				button:SetBackground(button.Icon);
			end
			self.ViewButton[tmpIndex].MenuEnabled=true; -- once there is an Option to disable the menu, this is where we would enforce it by not setting MenuEnabled to true
		end
		self.ViewButton[tmpIndex].Update=function()
			if self.ViewButton[tmpIndex].HideTimer<=Turbine.Engine.GetGameTime() then
				self.ViewButtonMenu:Close();
			end	
		end
		self.ViewButton[tmpIndex].MouseHover=function(button)
			if self.ViewButton[tmpIndex].MenuEnabled then
				self.ViewButtonMenu:GetItems():Get(1):SetText(button.HoverName)
				self.ViewButtonMenu:GetItems():Get(1).Click=function() button.MouseClick(button) end
				self.ViewButtonMenu:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20); -- display the context menu lower so it doesn't interfere with normal clicks and so it doesn't prematurely trigger the MouseLeave event
				self.ViewButton[tmpIndex].HideTimer=Turbine.Engine.GetGameTime()+2;
				self.ViewButton[tmpIndex]:SetWantsUpdates(true);
				self.ViewButton[tmpIndex].MenuEnabled=false;
			end
		end
		self.ViewButton[tmpIndex].MouseLeave=function(button)
			if self.PanelShowing~=button.Index then
				button:SetBackground(button.GreyIcon);
			end
			self.ViewButtonMenu:Close();
			self.ViewButton[tmpIndex]:SetWantsUpdates(false);
		end
		self.ViewButton[tmpIndex].MouseClick=function(button)
			self.ViewButton[tmpIndex]:SetWantsUpdates(false);
			if self.PanelShowing~=button.Index then
				self.PanelShowing=button.Index;
				local panelIndex;
				for panelIndex=1,#self.ViewButton do
					if panelIndex==button.Index then
						self.ViewButton[panelIndex]:SetBackground(self.ViewButton[panelIndex].Icon);
						if self.ViewPanel[panelIndex].IsValid~=nil then
							if self.ViewPanel[panelIndex]:IsValid() then
								self.ViewPanel[panelIndex]:SetVisible(true);
								self.ViewPanel[panelIndex]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1]);
							end
						else
							self.ViewPanel[panelIndex]:SetVisible(true);
						end
					else
						self.ViewButton[panelIndex]:SetBackground(self.ViewButton[panelIndex].GreyIcon);
						self.ViewPanel[panelIndex]:SetVisible(false);
					end
				end
				if self.ViewPanel[button.Index].Activated~=nil then
					self.ViewPanel[button.Index]:Activated();
				end
			end
		end
	end

	self.InvalidPanel=Turbine.UI.Label();
	self.InvalidPanel:SetParent(self);
	self.InvalidPanel:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.InvalidPanel:SetPosition((self:GetWidth()-self.InvalidPanel:GetWidth())/2,140);
	self.InvalidPanel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.InvalidPanel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36);
	self.InvalidPanel:SetText("n/a");

-- Create the Vault Panel
	self.ViewPanel[vaultPanel]=VaultPanel();
	self.ViewPanel[vaultPanel]:SetParent(self);
	self.ViewPanel[vaultPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[vaultPanel]:SetPosition((self:GetWidth()-self.ViewPanel[vaultPanel]:GetWidth())/2,140);
	self.ViewPanel[vaultPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[vaultPanel].SetView(self.VaultView);
	self.ViewPanel[vaultPanel].Index=2;

-- Create the Shared Storage Panel
	self.ViewPanel[sharedStoragePanel]=SharedStoragePanel();
	self.ViewPanel[sharedStoragePanel]:SetParent(self);
	self.ViewPanel[sharedStoragePanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[sharedStoragePanel]:SetPosition((self:GetWidth()-self.ViewPanel[vaultPanel]:GetWidth())/2,140);
	self.ViewPanel[sharedStoragePanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[sharedStoragePanel].SetView(self.SharedView);
	self.ViewPanel[sharedStoragePanel].Index=3;

-- Create the Equipped Items Panel
	self.ViewPanel[equippedItemsPanel]=EquippedItemsPanel();
	self.ViewPanel[equippedItemsPanel]:SetParent(self);
	self.ViewPanel[equippedItemsPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[equippedItemsPanel]:SetPosition((self:GetWidth()-self.ViewPanel[vaultPanel]:GetWidth())/2,140);
	self.ViewPanel[equippedItemsPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[equippedItemsPanel].Index=4;

-- Stats Panel
	self.ViewPanel[statisticsPanel]=StatsPanel();
	self.ViewPanel[statisticsPanel]:SetParent(self);
	self.ViewPanel[statisticsPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[statisticsPanel]:SetPosition((self:GetWidth()-self.ViewPanel[sharedStoragePanel]:GetWidth())/2,140);
	self.ViewPanel[statisticsPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[statisticsPanel].Index=5;

-- Crafting Panel
	self.ViewPanel[craftingPanel]=CraftingPanel();
	self.ViewPanel[craftingPanel]:SetParent(self);
	self.ViewPanel[craftingPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[craftingPanel]:SetPosition((self:GetWidth()-self.ViewPanel[equippedItemsPanel]:GetWidth())/2,140);
	self.ViewPanel[craftingPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[craftingPanel].Index=6;

-- Notes Panel
	self.ViewPanel[notesPanel]=NotesPanel();
	self.ViewPanel[notesPanel]:SetParent(self);
	self.ViewPanel[notesPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[notesPanel]:SetPosition((self:GetWidth()-self.ViewPanel[statisticsPanel]:GetWidth())/2,140);
	self.ViewPanel[notesPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[notesPanel].Index=7;

-- Reputation Panel
	self.ViewPanel[reputationPanel]=RepPanel();
	self.ViewPanel[reputationPanel]:SetParent(self);
	self.ViewPanel[reputationPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[reputationPanel]:SetPosition((self:GetWidth()-self.ViewPanel[craftingPanel]:GetWidth())/2,140);
	self.ViewPanel[reputationPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[reputationPanel].Index=8;

-- Traits Panel
	self.ViewPanel[traitsPanel]=TraitsPanel();
	self.ViewPanel[traitsPanel]:SetParent(self);
	self.ViewPanel[traitsPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[traitsPanel]:SetPosition((self:GetWidth()-self.ViewPanel[notesPanel]:GetWidth())/2,140);
	self.ViewPanel[traitsPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[traitsPanel].Index=9;

-- Wallet Panel
	self.ViewPanel[walletPanel]=WalletPanel();
	self.ViewPanel[walletPanel]:SetParent(self);
	self.ViewPanel[walletPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[walletPanel]:SetPosition((self:GetWidth()-self.ViewPanel[reputationPanel]:GetWidth())/2,140);
	self.ViewPanel[walletPanel]:LoadPanelData(currentCharacterName);
	self.ViewPanel[walletPanel].Index=10;

-- Inventory Panel
	self.ViewPanel[inventoryPanel]=InventoryPanel();
	self.ViewPanel[inventoryPanel]:SetParent(self);
	self.ViewPanel[inventoryPanel]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[inventoryPanel]:SetPosition((self:GetWidth()-self.ViewPanel[inventoryPanel]:GetWidth())/2,140);
	self.ViewPanel[inventoryPanel]:SetMouseVisible(false);
	self.ViewPanel[inventoryPanel]:SetVisible(true);
	self.ViewPanel[inventoryPanel].SetView(self.BagView);
	self.ViewPanel[inventoryPanel].Index=1;

	self.BottomBack=Turbine.UI.Control()
	self.BottomBack:SetParent(self);
	self.BottomBack:SetSize(self:GetWidth()-20,40);
	self.BottomBack:SetPosition(10,self:GetHeight()-47);
	self.BottomBack:SetBackColor(Turbine.UI.Color(0,0,0));
	self.BottomBack:SetMouseVisible(false);
	self.BottomPanelTiled=Turbine.UI.Control();
	self.BottomPanelTiled:SetParent(self);
	self.BottomPanelTiled:SetSize(self:GetWidth()-20,40);
	self.BottomPanelTiled:SetPosition(10,self:GetHeight()-47);
	self.BottomPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelTiled:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.BottomPanelTiled:SetBackColor(panelBackColor);
	self.BottomPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_tiled_bw.tga");
	self.BottomPanelTiled:SetMouseVisible(false);

	self.BottomPanelTiledTrim=Turbine.UI.Control()
	self.BottomPanelTiledTrim:SetParent(self);
	self.BottomPanelTiledTrim:SetSize(self:GetWidth()-20,5);
	self.BottomPanelTiledTrim:SetPosition(10,self:GetHeight()-47);
	self.BottomPanelTiledTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_tiled_trim.tga");
	self.BottomPanelTiledTrim:SetMouseVisible(false);

	self.BottomPanelLeft=Turbine.UI.Control();
	self.BottomPanelLeft:SetParent(self);
	self.BottomPanelLeft:SetSize(151,40);
	self.BottomPanelLeft:SetPosition(5,self:GetHeight()-47);
	self.BottomPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelLeft:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.BottomPanelLeft:SetBackColor(panelBackColor);
	self.BottomPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_left.tga");
	self.BottomPanelLeft:SetMouseVisible(false);

	self.BottomPanelLeftTrim=Turbine.UI.Control();
	self.BottomPanelLeftTrim:SetParent(self);
	self.BottomPanelLeftTrim:SetSize(151,40);
	self.BottomPanelLeftTrim:SetPosition(5,self:GetHeight()-47);
	self.BottomPanelLeftTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelLeftTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_left_trim.tga");
	self.BottomPanelLeftTrim:SetMouseVisible(false);

	self.BottomPanelCenter=Turbine.UI.Control();
	self.BottomPanelCenter:SetParent(self);
	self.BottomPanelCenter:SetSize(121,40);
	self.BottomPanelCenter:SetPosition((self:GetWidth()-self.BottomPanelCenter:GetWidth())/2+1,self:GetHeight()-47);
	self.BottomPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_center.tga");
	self.BottomPanelCenter:SetMouseVisible(false);

	self.BottomPanelRight=Turbine.UI.Control();
	self.BottomPanelRight:SetParent(self);
	self.BottomPanelRight:SetSize(151,40);
	self.BottomPanelRight:SetPosition(self:GetWidth()-self.BottomPanelRight:GetWidth()-4,self:GetHeight()-47);
	self.BottomPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelRight:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	self.BottomPanelRight:SetBackColor(panelBackColor);
	self.BottomPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_right.tga");
	self.BottomPanelRight:SetMouseVisible(false);

	self.BottomPanelRightTrim=Turbine.UI.Control();
	self.BottomPanelRightTrim:SetParent(self);
	self.BottomPanelRightTrim:SetSize(151,40);
	self.BottomPanelRightTrim:SetPosition(self:GetWidth()-self.BottomPanelRight:GetWidth()-4,self:GetHeight()-47);
	self.BottomPanelRightTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelRightTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_right_trim.tga");
	self.BottomPanelRightTrim:SetMouseVisible(false);

--[[
	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetStretchMode(1);
	self.MovingIcon:SetBackground(0x410081c0)
	-- for some reason, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetVisible(false);
]]--
	self.TrackMenu=Turbine.UI.ContextMenu()
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][42]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][43]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem("------------------------------------------------------"));
	self.TrackMenu:GetItems():Get(3):SetEnabled(false);
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][44]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][45]));

	self.QuantityMenu=Turbine.UI.ContextMenu()

	self.ItemControl={};
	self.ItemIcon={};
	self.ItemCol={};
	self.QtyCol={};
	self.SeparatorCol={};

	self.LoadingInventory=false;
	self.LoadInventory = function (sender, characterName)
		if not self.LoadingInventory then -- prevent any accidental recursion from quantity changes that also trigger item add/remove/move
			self.LoadingInventory=true;
			self.ViewPanel[inventoryPanel]:refreshStorage();
			self.ViewPanel[inventoryPanel]:LoadPanelData(characterName);
			self.LoadingInventory=false;
		end
	end

	self.KeyDown=function(sender, args)
		if bShowKeyDown==true then
			Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
		end
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			minimalWindow:SetVisible( false );
			inventoryWindow:SetVisible( false );
			minWindow:SetVisible( true );
		end
		if (args.Action==43) then -- toggle debug
			debug=not debug;
			
			if debugWindow==nil then
				debugWindow=DebugWindow();
			end
			debugWindow:SetVisible(debug);
		end
		if ( args.Action == 268435579 ) then -- reposition UI
		end

		if ( args.Action == 268435635 ) then -- toggle HUD
			hudVisible=not hudVisible;
			if hudVisible then
				inventoryWindow:SetVisible(mainVisible);
				minimalWindow:SetVisible(minVisible);
				minWindow:SetVisible(iconVisible);
			else
				mainVisible=inventoryWindow:IsVisible();
				minVisible=minimalWindow:IsVisible();
				iconVisible=minWindow:IsVisible();
				inventoryWindow:SetVisible(false);
				minimalWindow:SetVisible(false);
				minWindow:SetVisible(false);
			end
		end
		if self.ReplaceBags and ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag6 )
		then
			if inventoryWindow.MinimalHeader then
				minimalWindow:SetVisible(not minimalWindow:IsVisible());
				minWindow:SetVisible(not minimalWindow:IsVisible());
			else
				inventoryWindow:SetVisible(not inventoryWindow:IsVisible());
				minWindow:SetVisible(not inventoryWindow:IsVisible());
			end
		end
	end


	self.SizeChanged=function()
		local width,height=self:GetSize();
		if height<297 then
			self:SetHeight(297);
		elseif width<416 then
			self:SetWidth(416);
		else
			-- refresh only the currently displayed viewpanel to speed up response
			if self.PanelShowing~=nil then
				self.ViewPanel[self.PanelShowing]:SetSize(width-10,height-183);
--				if self.ViewPanel[self.PanelShowing].LoadPanelData~=nil then
--					self.ViewPanel[self.PanelShowing]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1])
--				end
			end
			self.InvalidPanel:SetSize(width-10,height-183);
			self.BottomPanelTiled:SetTop(height-47);
			self.BottomPanelTiledTrim:SetTop(height-47);
			self.BottomBack:SetTop(height-47);
			self.BottomPanelLeft:SetTop(height-47);
			self.BottomPanelLeftTrim:SetTop(height-47);
			self.BottomPanelCenter:SetTop(height-47);
			self.BottomPanelRight:SetTop(height-47);
			self.BottomPanelRightTrim:SetTop(height-47);
			self.OptionsButton:SetTop(self.BottomPanelLeft:GetTop()+4);
			self.TrackingButton:SetTop(self.BottomPanelLeft:GetTop()+4);
			if language==1 then
				self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
			elseif language==2 then
				self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
			else
				self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
			end
			self.TopPanelTiled:SetWidth(width-30);
			self.TopPanelTiledTrim:SetWidth(width-30);
			self.TopPanelCenter:SetLeft((self:GetWidth()-self.TopPanelCenter:GetWidth())/2-3);
			self.TopPanelRight:SetLeft(self:GetWidth()-self.TopPanelRight:GetWidth()-5);
			self.TopPanelRightTrim:SetLeft(self:GetWidth()-self.TopPanelRightTrim:GetWidth()-5);
			self.CloseButton:SetLeft(self:GetWidth()-self.CloseButton:GetWidth()-6);

			self.CharacterList:SetSize(self:GetWidth()-(self.SelCaption:GetWidth()+self.SelCaption:GetLeft())-65,self.CharacterList:GetHeight());
			self.RemoveCharButton:SetLeft(self.CharacterList:GetLeft()+self.CharacterList:GetWidth()+12);

			self.BagCapacityPanel:SetLeft((self:GetWidth()-self.BagCapacityPanel.MaxWidth)/2);
			self.BagCapacityPanel.Empty:SetLeft(self.BagCapacityPanel:GetLeft()+3)
			self.BagCapacityPanel.Full:SetLeft(self:GetWidth()-self.BagCapacityPanel.Empty:GetLeft()-self.BagCapacityPanel.Full:GetWidth()-6,64)
			self.BagCapacityPanel.Display:SetLeft((self:GetWidth()-self.BagCapacityPanel.Display:GetWidth())/2)

			self.SharedCapacityPanel:SetLeft((self:GetWidth()-self.SharedCapacityPanel.MaxWidth)/2);
			self.SharedCapacityPanel.Empty:SetLeft(self.SharedCapacityPanel:GetLeft()+3)
			self.SharedCapacityPanel.Full:SetLeft(self:GetWidth()-self.SharedCapacityPanel.Empty:GetLeft()-self.SharedCapacityPanel.Full:GetWidth()-6,64)
			self.SharedCapacityPanel.Display:SetLeft((self:GetWidth()-self.SharedCapacityPanel.Display:GetWidth())/2)

			self.VaultCapacityPanel:SetLeft((self:GetWidth()-self.VaultCapacityPanel.MaxWidth)/2);
			self.VaultCapacityPanel.Empty:SetLeft(self.VaultCapacityPanel:GetLeft()+3)
			self.VaultCapacityPanel.Full:SetLeft(self:GetWidth()-self.VaultCapacityPanel.Empty:GetLeft()-self.VaultCapacityPanel.Full:GetWidth()-6,64)
			self.VaultCapacityPanel.Display:SetLeft((self:GetWidth()-self.VaultCapacityPanel.Display:GetWidth())/2)

			local vbleft=(self:GetWidth()-32*#self.ViewButton-4*(#self.ViewButton-1))/2;
			local tmpIndex;
			for tmpIndex=1,#self.ViewButton do
				self.ViewButton[tmpIndex]:SetLeft(vbleft+(tmpIndex-1)*36);
			end

			self.BottomPanelTiled:SetWidth(self:GetWidth()-20);
			self.BottomPanelTiledTrim:SetWidth(self:GetWidth()-20);
			self.BottomBack:SetWidth(self:GetWidth()-20);
			self.BottomPanelCenter:SetLeft((self:GetWidth()-self.BottomPanelCenter:GetWidth())/2+1);
			self.BottomPanelRight:SetLeft(self:GetWidth()-self.BottomPanelRight:GetWidth()-4);
			self.BottomPanelRightTrim:SetLeft(self:GetWidth()-self.BottomPanelRightTrim:GetWidth()-4);
		end
		self.Sizing=true;
	end
	self.Sizing=false;
	self.MouseUp=function()
		if self.Sizing then
			-- refresh all of the viewpanels that are not currently displayed
			local panelIndex;
			local width,height=self:GetSize();
			for panelIndex=1,#self.ViewPanel do
				if panelIndex~=actualPanelShowing then
					self.ViewPanel[panelIndex]:SetSize(width-10,height-183);
				end
			end
		end
		self.Sizing=false;
	end
	self:SetResizable(true);
--[[
	self.SetHeight=function(sender,height)
		if height<297 then height=297 end;
		Turbine.UI.Lotro.Window.SetHeight(self,height);
		self:SetSize(self:GetWidth(),height)
		-- now move/resize all the controls
		local panelIndex;
		for panelIndex=1,#self.ViewPanel do
			self.ViewPanel[panelIndex]:SetHeight(height-183);
		end
		self.InvalidPanel:SetHeight(height-183);
		self.BottomPanelTiled:SetTop(height-47);
		self.BottomPanelTiledTrim:SetTop(height-47);
		self.BottomBack:SetTop(height-47);
		self.BottomPanelLeft:SetTop(height-47);
		self.BottomPanelLeftTrim:SetTop(height-47);
		self.BottomPanelCenter:SetTop(height-47);
		self.BottomPanelRight:SetTop(height-47);
		self.BottomPanelRightTrim:SetTop(height-47);
--		self.MovingIcon:SetTop(height-21);
		self.OptionsButton:SetTop(self.BottomPanelLeft:GetTop()+4);
		self.TrackingButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	end

	self.SetWidth=function(sender,width)
		-- in minimal mode, the width is already padded 10 pixels to account for normal mode, so just leave it.
		if width<414 then width=414 end;
		Turbine.UI.Lotro.Window.SetWidth(self,width);
		if language==1 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
		elseif language==2 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
		else
			self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
		end
		self.TopPanelTiled:SetWidth(width-30);
		self.TopPanelTiledTrim:SetWidth(width-30);
		self.TopPanelCenter:SetLeft((self:GetWidth()-self.TopPanelCenter:GetWidth())/2-3);
		self.TopPanelRight:SetLeft(self:GetWidth()-self.TopPanelRight:GetWidth()-5);
		self.TopPanelRightTrim:SetLeft(self:GetWidth()-self.TopPanelRightTrim:GetWidth()-5);
		self.CloseButton:SetLeft(self:GetWidth()-self.CloseButton:GetWidth()-6);

		local panelIndex;
		for panelIndex=1,#self.ViewPanel do
			self.ViewPanel[panelIndex]:SetWidth(width-10);
		end
		self.InvalidPanel:SetWidth(width-10);

		self.CharacterList:SetSize(self:GetWidth()-(self.SelCaption:GetWidth()+self.SelCaption:GetLeft())-65,self.CharacterList:GetHeight());
		self.RemoveCharButton:SetLeft(self.CharacterList:GetLeft()+self.CharacterList:GetWidth()+12);

		self.BagCapacityPanel:SetLeft((self:GetWidth()-self.BagCapacityPanel.MaxWidth)/2);
		self.BagCapacityPanel.Empty:SetLeft(self.BagCapacityPanel:GetLeft()+3)
		self.BagCapacityPanel.Full:SetLeft(self:GetWidth()-self.BagCapacityPanel.Empty:GetLeft()-self.BagCapacityPanel.Full:GetWidth()-6,64)
		self.BagCapacityPanel.Display:SetLeft((self:GetWidth()-self.BagCapacityPanel.Display:GetWidth())/2)

		self.SharedCapacityPanel:SetLeft((self:GetWidth()-self.SharedCapacityPanel.MaxWidth)/2);
		self.SharedCapacityPanel.Empty:SetLeft(self.SharedCapacityPanel:GetLeft()+3)
		self.SharedCapacityPanel.Full:SetLeft(self:GetWidth()-self.SharedCapacityPanel.Empty:GetLeft()-self.SharedCapacityPanel.Full:GetWidth()-6,64)
		self.SharedCapacityPanel.Display:SetLeft((self:GetWidth()-self.SharedCapacityPanel.Display:GetWidth())/2)

		self.VaultCapacityPanel:SetLeft((self:GetWidth()-self.VaultCapacityPanel.MaxWidth)/2);
		self.VaultCapacityPanel.Empty:SetLeft(self.VaultCapacityPanel:GetLeft()+3)
		self.VaultCapacityPanel.Full:SetLeft(self:GetWidth()-self.VaultCapacityPanel.Empty:GetLeft()-self.VaultCapacityPanel.Full:GetWidth()-6,64)
		self.VaultCapacityPanel.Display:SetLeft((self:GetWidth()-self.VaultCapacityPanel.Display:GetWidth())/2)

		local vbleft=(self:GetWidth()-32*#self.ViewButton-4*(#self.ViewButton-1))/2;
		local tmpIndex;
		for tmpIndex=1,#self.ViewButton do
			self.ViewButton[tmpIndex]:SetLeft(vbleft+(tmpIndex-1)*36);
		end

		self.BottomPanelTiled:SetWidth(self:GetWidth()-20);
		self.BottomPanelTiledTrim:SetWidth(self:GetWidth()-20);
		self.BottomBack:SetWidth(self:GetWidth()-20);
		self.BottomPanelCenter:SetLeft((self:GetWidth()-self.BottomPanelCenter:GetWidth())/2+1);
		self.BottomPanelRight:SetLeft(self:GetWidth()-self.BottomPanelRight:GetWidth()-4);
		self.BottomPanelRightTrim:SetLeft(self:GetWidth()-self.BottomPanelRightTrim:GetWidth()-4);
--		self.MovingIcon:SetLeft(width-21);
		self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
	end

	self.MouseDown=function(sender,args)
		if (args.Y>self:GetHeight()-15) and (args.X>self:GetWidth()-15) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x41007e20)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y>self:GetHeight()-12) then
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-22);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x410081c0)
			self.MovingIcon:SetVisible(true);
		elseif (args.X>self:GetWidth()-12) then
			self.MoveX=args.X;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-22);
			self.MovingIcon:SetBackground(0x410081bf)
			self.MovingIcon:SetVisible(true);
		else
			self.MoveX=-1;
			self.MoveY=-1;
		end
	end

	self.MouseMove=function(sender,args)
		if (self.MoveY>-1) then
			if args.Y~= self.MoveY then
				local newHeight=self:GetHeight()-(self.MoveY-args.Y);
				if newHeight<215 then newHeight=215 end;
				if newHeight>(Turbine.UI.Display.GetHeight()-self:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-self:GetTop() end;
				local newX=args.X-22;
				if newX<-13 then newX=-13 end
				if newX>(self:GetWidth()-18) then newX=self:GetWidth()-18 end
				self.MovingIcon:SetLeft(newX);
				self:SetHeight(newHeight);
				self.MoveY=args.Y;
			end
		end
		if (self.MoveX>-1) then
			if args.X~= self.MoveX then
				local newWidth=self:GetWidth()-(self.MoveX-args.X);
				if newWidth<414 then newWidth=414 end;
				if newWidth>(Turbine.UI.Display.GetWidth()-self:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-self:GetLeft() end;
				local newY=args.Y-22;
				if newY<-13 then newY=-13 end
				if newY>(self:GetHeight()-18) then newY=self:GetHeight()-18 end
				self.MovingIcon:SetTop(newY);
				self:SetWidth(newWidth);
				self.MoveX=args.X;
			end
		end
	end
	self.MouseUp=function(sender,args)
		self.MovingIcon:SetVisible(false);
		self.MoveX=-1;
		self.MoveY=-1;
	end
]]--
	self.OptionsButton=Turbine.UI.Control();
	self.OptionsButton:SetParent(self);
	self.OptionsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	self.OptionsButton:SetSize(32,32);
	self.OptionsButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	self.OptionsButton:SetLeft(self.BottomPanelLeft:GetLeft()+18);
	self.OptionsButton.MouseEnter = function()
		self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options_hover.tga");
	end
	self.OptionsButton.MouseLeave = function()
		self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	end
	self.OptionsButton.MouseClick=function()
		optWindow:SetVisible(true);
	end

	self.TrackingButton=Turbine.UI.Control();
	self.TrackingButton:SetParent(self);
	self.TrackingButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack.tga");
	self.TrackingButton:SetSize(32,32);
	self.TrackingButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	self.TrackingButton:SetLeft(self.BottomPanelLeft:GetLeft()+55);
	self.TrackingButton.MouseEnter = function()
		self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack_hover.tga");
	end
	self.TrackingButton.MouseLeave = function()
		self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack.tga");
	end
	self.TrackingButton.MouseClick=function()
		trackWindow:SetVisible(true);
	end

-- set ZOrder so that the drop downs can cover other items, etc
	self.ViewPanel[notesPanel]:SetZOrder(1);
	self.ViewPanel[craftingPanel]:SetZOrder(1);
	self.ViewPanel[statisticsPanel]:SetZOrder(1);
	self.ViewPanel[equippedItemsPanel]:SetZOrder(2);
	self.ViewPanel[inventoryPanel]:SetZOrder(3);
	self.TopPanelCenter:SetZOrder(8);
	self.TitleIcon:SetZOrder(9);
	self.BottomBack:SetZOrder(1);
	self.BottomPanelTiled:SetZOrder(10);
	self.BottomPanelTiledTrim:SetZOrder(10);
	self.BottomPanelLeft:SetZOrder(11);
	self.BottomPanelLeftTrim:SetZOrder(12);

	self.BottomPanelCenter:SetZOrder(12);
	self.BottomPanelRight:SetZOrder(13);
	self.BottomPanelRightTrim:SetZOrder(14);
	self.OptionsButton:SetZOrder(14);
	self.TrackingButton:SetZOrder(15);
--	self.MovingIcon:SetZOrder(17);
	self.SelCaption:SetZOrder(18);
	self.BagCapacityPanel:SetZOrder(20);
	self.BagCapacityPanel.Empty:SetZOrder(22)
	self.BagCapacityPanel.Display:SetZOrder(24);
	self.BagCapacityPanel.Full:SetZOrder(26)

	self.SharedCapacityPanel:SetZOrder(20);
	self.SharedCapacityPanel.Empty:SetZOrder(22)
	self.SharedCapacityPanel.Display:SetZOrder(24);
	self.SharedCapacityPanel.Full:SetZOrder(26)

	self.VaultCapacityPanel:SetZOrder(20);
	self.VaultCapacityPanel.Empty:SetZOrder(22)
	self.VaultCapacityPanel.Display:SetZOrder(24);
	self.VaultCapacityPanel.Full:SetZOrder(26)

	local tmpvb
	for tmpvb=1,#self.ViewButton do
		self.ViewButton[tmpvb]:SetZOrder(28);
	end
	self.CharacterList:SetZOrder(52);
	self.RemoveCharButton:SetZOrder(54);
	self.RemoveConfirmation:SetZOrder(56);

	self:SetWantsKeyEvents(true);
	self:SetWantsUpdates(true)

	self.RemoveShellCommands=function(sender,args)
		Turbine.Shell.RemoveCommand(self.shellCmd)
	end
	self.shellCmd=Turbine.ShellCommand();
	local numberOfCommandsRegistered = Turbine.Shell.AddCommand("AltInventory",self.shellCmd);

	self.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == "altinventory") then
			if (string.lower(args)=="show") then
				minWindow:SetVisible(false);
				if self.MinimalHeader then
					minimalWindow:SetVisible(true);
				else
					self:SetVisible(true);
				end
			elseif (string.lower(args)=="hide") then
				minimalWindow:SetVisible(false);
				self:SetVisible(false);
				minWindow:SetVisible(true);
			elseif (string.lower(args)=="toggle") then
				if self.MinimalHeader then
					minimalWindow:SetVisible(not minimalWindow:IsVisible());
				else
					inventoryWindow:SetVisible(not inventoryWindow:IsVisible());
				end
				minWindow:SetVisible(not minWindow:IsVisible());
			elseif (string.lower(args)=="debug on") then
				debug=true;
				if debugWindow==nil then
					debugWindow=DebugWindow();
				else
					debugWindow:SetVisible(true);
				end
				debugWindow:SetVisible(true);
			elseif (string.lower(args)=="debug off") then
				debug=false;
				if debugWindow~=nil then
					debugWindow:SetVisible(false);
				end
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /AltInventory show");
				Turbine.Shell.WriteLine("       Displays the Alt Inventory main window.");
				Turbine.Shell.WriteLine("  /AltInventory hide");
				Turbine.Shell.WriteLine("       Hides the Alt Inventory main window.");
				Turbine.Shell.WriteLine("  /AltInventory toggle");
				Turbine.Shell.WriteLine("       Toggles the Alt Inventory main window (shows it if it was hidden, hides it if it was showing).");
			end
		end
	end
	self.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /AltInventory show\n       Displays the Alt Inventory main window.\n  /AltInventory hide\n       Hides the Alt Inventory main window.\n  /AltInventory toggle\n       Toggles the Alt Inventory main window (shows it if it was hidden, hides it if it was showing).");
	end

	self.shellCmd.GetShortHelp = function(sender, cmd)
		return("AltInventory - usage: /AltInventory show | hide | toggle");
	end
	self.Closing=function()
	end

	self.SetReplaceBags=function(sender,value)
		self.ReplaceBags=value;
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, not self.ReplaceBags );
	end

	self.GetReplaceBags=function()
		return self.ReplaceBags;
	end

	self.GetShowIconWhenMinimized=function()
		return self.ShowIconWhenMinimized;
	end
	self.SetShowIconWhenMinimized=function(sender,value)
		self.ShowIconWhenMinimized=value;
		if value then
			minWindow:SetSize(32,32);
		else
			minWindow:SetSize(0,0);
		end
	end

	self.GetCharItemInfo=function(sender,itemName)
		-- get the quantity of the specified item for the current character
		local charIndex;
		local itemIndex;
		local node=nil;
		local bagQty=0;
		local vaultQty=0;
		local bags=BagData[currentCharacterName];
		for itemIndex=1,#bags do
			local curItem=bags[itemIndex];
			if curItem[5]==itemName then
				if curItem[6]==nil or curItem[6]==0 then
					bagQty=bagQty+1;
				else
					bagQty=bagQty+curItem[6];
				end
				node={curItem[5],0,{},curItem[8],curItem[9],curItem[10],curItem[11],curItem[12],curItem[13],curItem[3]};
			end
		end
		local vault=VaultData[currentCharacterName]
		for itemIndex=1,#vault do
			local curItem=vault[itemIndex];
			if curItem[5]==itemName then
				if curItem[6]==nil or curItem[6]==0 then
					vaultQty=vaultQty+1;
				else
					vaultQty=vaultQty+curItem[6];
				end
				if node==nil then
					node={curItem[5],0,{},curItem[8],curItem[9],curItem[10],curItem[11],curItem[12],curItem[13],curItem[3]};
				end
			end
		end
		if node~=nil then
			node[2]=bagQty+vaultQty;
			node[3]={{currentCharacterName,bagQty,vaultQty}};
		end
		return(node);
	end
	self.GetAllItemInfo=function(sender,itemName)
		-- returns a table with the first entry being the itemquantity, and the second entry being a table of all of the users and their qty's
		local itemIndex;
		local node=nil;
		local bags=BagData["ALL"];
		local bagQty=0;
		local vaultQty=0;
		for itemIndex=1,#bags do
			local curItem=bags[itemIndex];
			if curItem[5]==itemName then
				if node==nil then
					node={curItem[5],0,{},curItem[8],curItem[9],curItem[10],curItem[11],curItem[12],curItem[13],curItem[3]};
				end
				local charIndex,data;
				for charIndex,data in ipairs(curItem[7]) do
					node[3][charIndex]={data[1],data[2],0};
				end
				if curItem[6]==nil or curItem[6]==0 then
					bagQty=bagQty+1;
				else
					bagQty=bagQty+curItem[6];
				end
			end
		end
		local vault=VaultData["ALL"];
		for itemIndex=1,#vault do
			local curItem=vault[itemIndex];
			if curItem[5]==itemName then
				if node==nil then
					node={curItem[5],0,{},curItem[8],curItem[9],curItem[10],curItem[11],curItem[12],curItem[13],curItem[3]};
					-- need to push the contribution qty to the third element
					local charIndex,data;
					for charIndex,data in ipairs(curItem[7]) do
						node[3][charIndex]={data[1],0,data[2]};
					end
				else
					-- need to merge the contributions
					local nodeIndex,nodeData,vaultIndex,vaultData;
					local processed={};
					for nodeIndex,nodeData in node[3] do
						for vaultIndex,vaultData in curItem[7] do
							if nodeData[1]==vaultData[1] then
								processed[vaultData[1]]=true;
								nodeData[3]=vaultData[2];
							end
						end
					end
					for vaultIndex,vaultData in curItem[7] do
						if processed[vaultData[1]]==nil then
							node[3][#node[3]+1]={vaultData[1],0,vaultData[2]};
						end
					end
				end
				if curItem[6]==nil or curItem[6]==0 then
					vaultQty=vaultQty+1
				else
					vaultQty=vaultQty+curItem[6]
				end
			end
		end
		if node~=nil then
			node[2]=bagQty+vaultQty;
		end
		local node2=self:GetCharItemInfo(itemName);
		if node==nil then
			node=node2;
		else
			if node2~=nil then
				node[2]=node[2]+node2[2];
				node[3][#node[3]+1]={currentCharacterName,node2[3][1][2],node2[3][1][3]};
			end
		end
		local shared=SharedStorageData;
		local sharedQty=0;
		for itemIndex=1,#shared do
			local curItem=shared[itemIndex];
			if curItem[5]==itemName then
				if curItem[6]==nil or curItem[6]==0 then
					sharedQty=sharedQty+1;
				else
					sharedQty=sharedQty+curItem[6];
				end
				if node==nil then
					node={curItem[5],0,{},curItem[8],curItem[9],curItem[10],curItem[11],curItem[12],curItem[13],curItem[3]};
				end
			end
		end
		if sharedQty~=0 then
			node[2]=node[2]+sharedQty;
			node[3][#node[3]+1]={"SHARED",sharedQty,0};
		end
		return(node);
	end
	self.SetTrimColor=function()
		self.CharacterList:SetBorderColor(trimColor);
		self.RemoveConfirmation:SetBackColor(trimColor);
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetTrimColor ~= nil then
				self.ViewPanel[tmpIndex]:SetTrimColor();
			end
		end
	end
	self.SetBackColor=function()
		self.CharacterList:SetBackColor(backColor);
		self.CharacterList:SetCurrentBackColor(backColor);
		self.RemoveConfirmation.Text:SetBackColor(backColor);
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetBackgroundColor ~= nil then
				self.ViewPanel[tmpIndex]:SetBackgroundColor();
			end
		end
	end
	self.SetPanelBackColor=function()
		self.TopPanelTiled:SetBackColor(panelBackColor);
		self.TopPanelLeft:SetBackColor(panelBackColor);
		self.TopPanelRight:SetBackColor(panelBackColor);
		self.BottomPanelTiled:SetBackColor(panelBackColor);
		self.BottomPanelLeft:SetBackColor(panelBackColor);
		self.BottomPanelRight:SetBackColor(panelBackColor);
	end

	self.SetListTextColor=function()
		self.CharacterList:SetTextColor( listTextColor );
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetListTextColor ~= nil then
				self.ViewPanel[tmpIndex]:SetListTextColor();
			end
		end
	end
	self.SetFontColor=function()
		self.SelCaption:SetForeColor(fontColor);
		self.RemoveConfirmation.Text:SetForeColor(fontColor);
		self.BagCapacityPanel.Display:SetForeColor(fontColor);
		self.SharedCapacityPanel.Display:SetForeColor(fontColor);
		self.VaultCapacityPanel.Display:SetForeColor(fontColor);
		-- Bag Separator columns
		local tmpIndex;
		for tmpIndex=1,#self.SeparatorCol do
			self.SeparatorCol[tmpIndex]:SetForeColor(fontColor);
		end

		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetFontColor ~= nil then
				self.ViewPanel[tmpIndex]:SetFontColor();
			end
		end
	end
	self.SetHeadingsColor=function()
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetHeadingsColor ~= nil then
				self.ViewPanel[tmpIndex]:SetHeadingsColor();
			end
		end
	end
	self.SetLanguage=function()
		classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
		raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]}}
		self:SetText("      "..Resource[language][2].."      ");
		if language==1 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
		elseif language==2 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
		else
			self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
		end
		self.SelCaption:SetText(Resource[language][15]..":");
		self.BagCapacityPanel.Empty:SetText(Resource[language][21]);
		self.BagCapacityPanel.Display:SetText(Resource[language][22].." ("..self.Filled.."/"..self.Capacity..")")
		self.BagCapacityPanel.Full:SetText(Resource[language][23]);
		self.SharedCapacityPanel.Empty:SetText(Resource[language][21]);
		self.SharedCapacityPanel.Display:SetText(Resource[language][22].." ("..self.Filled.."/"..self.Capacity..")")
		self.SharedCapacityPanel.Full:SetText(Resource[language][23]);
		self.VaultCapacityPanel.Empty:SetText(Resource[language][21]);
		self.VaultCapacityPanel.Display:SetText(Resource[language][22].." ("..self.Filled.."/"..self.Capacity..")")
		self.VaultCapacityPanel.Full:SetText(Resource[language][23]);
		self.CharacterList.ListData:GetItem(1):SetText(Resource[language][29].." ");
		if self.CharacterList.ListData:GetSelectedIndex()==1 then self.CharacterList.CurrentValue:SetText(Resource[language][29].." ") end;
		self.TrackMenu:GetItems():Get(1):SetText(Resource[language][42]);
		self.TrackMenu:GetItems():Get(2):SetText(Resource[language][43]);
		self.TrackMenu:GetItems():Get(4):SetText(Resource[language][44]);
		self.TrackMenu:GetItems():Get(5):SetText(Resource[language][45]);

		-- Bag Separator columns
		for tmpIndex=1,#self.SeparatorCol do
			self.SeparatorCol[tmpIndex]:SetText(Resource[language][256].." "..tmpIndex);
		end
		-- Minimal Window texts
		minimalWindow.MenuBar.OptMenu:SetText(Resource[language][49]);
		minimalWindow.MenuBar.TrackMenu:SetText(Resource[language][50]);
		minimalWindow.MenuBar.PanelMenu:SetText(Resource[language][54]);
		minimalWindow.DisplayMenu:GetItems():Get(1):SetText(Resource[language][51]);
		minimalWindow.DisplayMenu:GetItems():Get(2):SetText(Resource[language][52]);
		minimalWindow.DisplayMenu:GetItems():Get(3):SetText(Resource[language][343]);
		minimalWindow.DisplayMenu:GetItems():Get(4):SetText(Resource[language][344]);
		minimalWindow.DisplayMenu:GetItems():Get(5):SetText(Resource[language][53]);
		minimalWindow.DisplayMenu:GetItems():Get(6):SetText(Resource[language][323]);
		minimalWindow.DisplayMenu:GetItems():Get(7):SetText(Resource[language][333]);
		minimalWindow.DisplayMenu:GetItems():Get(8):SetText(Resource[language][335]);
		minimalWindow.DisplayMenu:GetItems():Get(9):SetText(Resource[language][336]);
		minimalWindow.DisplayMenu:GetItems():Get(10):SetText(Resource[language][341]);
		local tmpIndex;
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetLanguage ~= nil then
				self.ViewPanel[tmpIndex]:SetLanguage();
			end
		end
		self.ViewButton[1].HoverName=Resource[language][52];
		self.ViewButton[2].HoverName=Resource[language][343];
		self.ViewButton[3].HoverName=Resource[language][344];
		self.ViewButton[4].HoverName=Resource[language][51];
		self.ViewButton[5].HoverName=Resource[language][53];
		self.ViewButton[6].HoverName=Resource[language][323];
		self.ViewButton[7].HoverName=Resource[language][333];
		self.ViewButton[8].HoverName=Resource[language][335];
		self.ViewButton[9].HoverName=Resource[language][336];
		self.ViewButton[10].HoverName=Resource[language][341];
	end
end

function AltInvWindow:SetLoadMinimized(value)
	if value==nil then value=false end;
	self.LoadMinimized=(value==true);
end
function AltInvWindow:GetLoadMinimized()
	return (self.LoadMinimized);
end
function AltInvWindow:SetMinimalHeader(value)
	if value==nil then value=false end;
	self.MinimalHeader=(value==true);
	if self.MinimalHeader then
		if inventoryWindow:IsVisible() then
			inventoryWindow.SelCaption:SetParent(minimalWindow);
			inventoryWindow.SelCaption:SetPosition(0,24);
			inventoryWindow.CharacterList:SetParent(minimalWindow);
			inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			local panelIndex;
			local width,height=minimalWindow:GetSize();
			for panelIndex=1,#inventoryWindow.ViewPanel do
				inventoryWindow.ViewPanel[panelIndex]:SetParent(minimalWindow);
				inventoryWindow.ViewPanel[panelIndex]:SetPosition(0,40);
				inventoryWindow.ViewPanel[panelIndex]:SetSize(width,height-43);
			end
			inventoryWindow.RemoveCharButton:SetParent(minimalWindow);
			inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			inventoryWindow.RemoveConfirmation:SetParent(minimalWindow);
			minimalWindow:SetPosition(inventoryWindow:GetPosition());
			minimalWindow:SetWidth(inventoryWindow:GetWidth());
			minimalWindow:SetHeight(inventoryWindow:GetHeight());
			-- we have to use the ancestor function to avoid triggering the minWindow and other problems from the overridden function
			Turbine.UI.Lotro.Window.SetVisible( inventoryWindow, false );
			minimalWindow:SetVisible(true);
		end
	else
		if minimalWindow:IsVisible() then
			minimalWindow:SetVisible(false);
			inventoryWindow.SelCaption:SetParent(inventoryWindow);
			inventoryWindow.SelCaption:SetPosition(15,39);
			inventoryWindow.CharacterList:SetParent(inventoryWindow);
			inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			local panelIndex;
			local width,height=inventoryWindow:GetSize();
			for panelIndex=1,#inventoryWindow.ViewPanel do
				inventoryWindow.ViewPanel[panelIndex]:SetParent(inventoryWindow);
				inventoryWindow.ViewPanel[panelIndex]:SetPosition(5,139);
				inventoryWindow.ViewPanel[panelIndex]:SetSize(width-10,height-183);
			end

			inventoryWindow.RemoveCharButton:SetParent(inventoryWindow);
			inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+12,inventoryWindow.CharacterList:GetTop());
			inventoryWindow.RemoveConfirmation:SetParent(inventoryWindow);
			inventoryWindow:SetPosition(minimalWindow:GetPosition());
			inventoryWindow:SetWidth(inventoryWindow:GetWidth());
			inventoryWindow:SetHeight(inventoryWindow:GetHeight());
			inventoryWindow:SetVisible(true);
		end
	end
end
function AltInvWindow:GetMinimalHeader()
	return (self.MinimalHeader);
end

function AltInvWindow:SetBagSeparator(value)
	if value==nil then value=false end;
	self.BagSeparator=(value==true);
end
function AltInvWindow:GetBagSeparator()
	return (self.BagSeparator);
end
function AltInvWindow:SetEnabled(state)
	self.CharacterList:SetEnabled(state);
	self.RemoveCharButton:SetMouseVisible(state);
	local panelIndex;
	for panelIndex=1,#self.ViewPanel do
		if self.ViewPanel[panelIndex].SetEnabled~=nil then
			self.ViewPanel[panelIndex]:SetEnabled(state)
		end
	end
	self.OptionsButton:SetMouseVisible(state);
	self.TrackingButton:SetMouseVisible(state);
end

function AltInvWindow:SetVisible(value)
	if self.MinimalHeader and minimalWindow~= nil then
		Turbine.UI.Window.SetVisible( minimalWindow, value );
	else
		Turbine.UI.Lotro.Window.SetVisible( self, value );
	end
	if ( value == true ) then
		if (self.CharacterList:GetText()==currentCharacterName) then self:LoadInventory(currentCharacterName) end;
	end
end

function AltInvWindow:Update( sender, args )
	if (Plugins["AltInventory"] ~= nil) and (not self.Loaded) then
		self.Loaded=true;
		Turbine.Shell.WriteLine("AltInventory "..Plugins["AltInventory"]:GetVersion()..Resource[language][47]);
		Plugins["AltInventory"].Unload = function(self,sender,args)
			UnloadPlugin();
		end
		-- force a refresh of the inventory views.
		self.ViewPanel[inventoryPanel]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1])
		self.ViewPanel[vaultPanel]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1])
		self.ViewPanel[sharedStoragePanel]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1])
	end
	if self.NeedsRefresh==true then -- for some reason trying to use the value as a boolean sometimes fails.. must not be being set somewhere
		-- updates were just turned on so that we could handle an item quantity change asynchronously
		self:SetWantsUpdates(false);
		self.NeedsRefresh=false;
		self.ViewPanel[inventoryPanel]:refreshStorage();
		self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
	end
end

LoadData();

inventoryWindow=AltInvWindow();
minimalWindow=MinInvWindow();
minimalWindow:SetPosition(inventoryWindow:GetPosition());
minimalWindow:SetSize(inventoryWindow:GetSize());

minWindow=MinimizedWindow();
minWindow:SetZOrder(1); -- prevent built-in resources from covering the icon
if inventoryWindow:GetShowIconWhenMinimized() then
	minWindow:SetSize(32,32);
else
	minWindow:SetSize(0,0);
end

trackWindow=TrackingWindow();
if inventoryWindow.MinimalHeader then
-- need to move the characterlist and viewpanels to an minimal sized window and only show that
	inventoryWindow.SelCaption:SetParent(minimalWindow);
	inventoryWindow.SelCaption:SetPosition(0,24);
	inventoryWindow.CharacterList:SetParent(minimalWindow);
	inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
	local panelIndex;
	for panelIndex=1,#inventoryWindow.ViewPanel do
		inventoryWindow.ViewPanel[panelIndex]:SetParent(minimalWindow);
		inventoryWindow.ViewPanel[panelIndex]:SetPosition(0,40);
	end
	inventoryWindow.RemoveCharButton:SetParent(minimalWindow);
	inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
	inventoryWindow.RemoveConfirmation:SetParent(minimalWindow);
	minimalWindow:SetWidth(inventoryWindow:GetWidth());
	minimalWindow:SetHeight(inventoryWindow:GetHeight());
end
if inventoryWindow.LoadMinimized then
	minWindow:SetVisible(true);
else
	if inventoryWindow.MinimalHeader then
		minimalWindow:SetVisible(true);
	else
		inventoryWindow:SetVisible(true);
	end
end

optWindow=OptionsWindow();
customThresholdWindow=CustomThresholdWindow();

InitSelections()

inventoryWindow.ViewPanel[inventoryPanel].FilterList.CurrentValue:SetText(inventoryWindow.ViewPanel[inventoryPanel].FilterList.ListData:GetItem(1):GetText());
inventoryWindow.ViewPanel[inventoryPanel].FilterList.CurrentValue.DataValue=inventoryWindow.ViewPanel[inventoryPanel].FilterList.ListData:GetItem(1).DataValue;
inventoryWindow:LoadInventory(currentCharacterName);

trackWindow:SetZOrder(inventoryWindow:GetZOrder()+1);
customThresholdWindow:SetZOrder(trackWindow:GetZOrder()+1);
optWindow:SetZOrder(customThresholdWindow:GetZOrder()+1);

trackWindow:LoadData();

-- get player changes
LevelChanged=function()
	characterListArray[currentCharIndex][2]=localPlayer:GetLevel();
end
BaseMaxMoraleChanged=function()
	characterListArray[currentCharIndex][3]=localPlayer:GetBaseMaxMorale();
end
BaseMaxPowerChanged=function()
	characterListArray[currentCharIndex][4]=localPlayer:GetBaseMaxPower();
end
AddCallback(localPlayer,"LevelChanged","LevelChanged")
AddCallback(localPlayer,"BaseMaxMoraleChanged","BaseMaxMoraleChanged")
AddCallback(localPlayer,"BaseMaxPowerChanged","BaseMaxPowerChanged")


--**** Turbine does not fire events for the other attributes :(
--**** we can temporarily handle this with a timed (1/second) refresh of the attributes
--**** this routine may cause excessive load when running in a raid so it is only enabled when the inventory window is visible
inventoryWindow.ViewPanel[statisticsPanel].timer=Turbine.Engine.GetGameTime()+1
inventoryWindow.ViewPanel[statisticsPanel].Update=function()
	if Turbine.Engine.GetGameTime()>=inventoryWindow.ViewPanel[statisticsPanel].timer then
		GetAttributes();
		if characterListArray[inventoryWindow.CharacterList:GetValue()]~=nil and characterListArray[inventoryWindow.CharacterList:GetValue()][1]==currentCharacterName then
			-- since this is asynchronous, the index can temporarily be invalid when processing a RemoveCharacter event
			inventoryWindow.ViewPanel[statisticsPanel]:LoadPanelData(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
		end
		inventoryWindow.ViewPanel[statisticsPanel].timer=Turbine.Engine.GetGameTime()+1
	end
end
inventoryWindow.ViewPanel[statisticsPanel]:SetWantsUpdates(inventoryWindow.ViewPanel[statisticsPanel]:GetParent():IsVisible())

if dataLoadError then
	-- warn the user and give them the opportunity to exit without saving
end


-- inventory tables have the following structure
-- -- [1] index in backpack
-- -- [2] item durability
-- -- [3] item quality
-- -- [4] item wearstate
-- -- [5] item Name (singular name, we don't have access to plurals yet)
-- -- [6] item quantity
-- -- [7] table of individual quantities (only valid for AllItemArray
-- -- [7][x][1] Character Index - index into characterListArray
-- -- [7][x][2] Quantity
-- -- [8] icon background resource id
-- -- [9] icon image resource id
-- -- [10] icon quality resource id (not currently used)
-- -- [11] icon shadow resource id (not currently used)
-- -- [12] icon underlay image resource id (not currently used)
-- -- [13] image category

-- the character table has the following structure
-- -- [1]==Character Name
-- -- [2]=Level
-- -- [3]=Max Morale
-- -- [4]=Max Power
-- -- [5]=Race
-- -- [6]=Class
-- -- [7]=Race Attributes();
-- -- [8]=Class Attributes
-- -- [9]=Alignment(); -- 1=Freep
-- -- [10]=Vocation -- manually entered and maintained
-- -- [11]=attributes:GetMoney();
-- -- [12]=attributes:GetAcidMitigation();
-- -- [13]=attributes:GetAgility();
-- -- [14]=attributes:GetArmor();
-- -- [15]=attributes:GetBaseAgility();
-- -- [16]=attributes:GetBaseCriticalHitAvoidance();
-- -- [17]=attributes:GetBaseCriticalHitChance();
-- -- [18]=attributes:GetBaseFate();
-- -- [19]=attributes:GetBaseMight();
-- -- [20]=attributes:GetBaseResistance();
-- -- [21]=attributes:GetBaseVitality();
-- -- [22]=attributes:GetBaseWill();
-- -- [23]=attributes:GetBlock();
-- -- [24]=attributes:GetCommonMitigation();
-- -- [25]=attributes:GetDiseaseResistance();
-- -- [26]=attributes:GetEvade();
-- -- [27]=attributes:GetFate();
-- -- [28]=attributes:GetFearResistance();
-- -- [29]=attributes:GetFinesse();
-- -- [30]=attributes:GetFireMitigation();
-- -- [31]=attributes:GetFrostMitigation();
-- -- [32]=attributes:GetIncomingHealing();
-- -- [33]=attributes:GetLightningMitigation();
-- -- [34]=attributes:GetMeleeCriticalHitAvoidance();
-- -- [35]=attributes:GetMeleeCriticalHitChance();
-- -- [36]=attributes:GetMeleeDamage();
-- -- [37]=attributes:GetMeleeDefence();
-- -- [38]=attributes:GetMight();
-- -- [39]=attributes:GetOutgoingHealing();
-- -- [40]=attributes:GetParry();
-- -- [41]=attributes:GetPhysicalMitigation();
-- -- [42]=attributes:GetPoisonResistance();
-- -- [43]=attributes:GetRangeCriticalHitAvoidance();
-- -- [44]=attributes:GetRangeCriticalHitChance();
-- -- [45]=attributes:GetRangeDamage();
-- -- [46]=attributes:GetRangeDefence();
-- -- [47]=attributes:GetShadowMitigation();
-- -- [48]=attributes:GetTacticalCriticalHitAvoidance();
-- -- [49]=attributes:GetTacticalCriticalHitChance();
-- -- [50]=attributes:GetTacticalDamage();
-- -- [51]=attributes:GetTacticalDefence();
-- -- [52]=attributes:GetTacticalMitigation();
-- -- [53]=attributes:GetVitality();
-- -- [54]=attributes:GetWill();
-- -- [55]=attributes:GetWoundResistance();

--GaranStuff.AltInventory.Table.Dump(Turbine)
--testdialog=PopUpDialog("test1","just testing with a really long message to see how multiple lines are handled. let's see how it handles 3 lines. and now, the coup-de-gras, let's give it 4 lines :)",3,"abcdefghi","just testing","hmmmm")
--testdialog=PopUpDialog("test1","just testing",3,"abcdefghi","just testing","hmmmm")
--testdialog.Buttons[2].Click=function(sender)
--	Turbine.Shell.WriteLine("button 2 pressed");
--	sender:GetParent():SetVisible(false);
--end
-- if we had the itemID and name for items, we could create popups for the offline items
--<Examine:IIDDID:0x0000000000000000:0xitemID>[name]<\Examine>

if debug then
	debugWindow=DebugWindow();
	debugWindow:SetVisible(true);
end
