-- Generic Panel skeleton

euroFormat=(tonumber("1,000")==1); -- redundant but harmless

function LoadData()
	QuestLog=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_QuestLog");
	if QuestLog==nil then
		QuestLog={};
	end
end
LoadData();

QuestPanel=class(Turbine.UI.Control)
function QuestPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackColor(backColor);
	self:SetSize(200,200);
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;

-- create panel controls
	self.VP=Turbine.UI.Label();
	self.VP:SetSize(190,60*#Faction+100); -- we pad the bottom by 100 to allow enough room for the drop down lists
--	self.VP:SetBackColor(backColor);
	self.VP:SetParent(self);
	
	self.VScroll=Turbine.UI.Lotro.ScrollBar();
	self.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.VScroll:SetParent(self);
	self.VScroll:SetBackColor(backColor);
	self.VScroll:SetPosition(self:GetWidth()-12,0);
	self.VScroll:SetWidth(12);
	self.VScroll:SetHeight(200);
	self.VScroll:SetMinimum(0);
	self.VScroll.ValueChanged=function(sender,args)
		self.VP:SetTop(-self.VScroll:GetValue());
	end

	self:SetVisible(false);

	self.IsValid=function()
		return (characterListArray[self.characterIndex][9]==Turbine.Gameplay.Alignment.FreePeople);
	end

	self.LoadPanelData=function(sender, characterName)
		local charIndex;
		for charIndex=1,#characterListArray do
			if characterListArray[charIndex][1]==characterName then
				self.characterIndex=charIndex;
				if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
					self:SetVisible(self:IsValid())
				end
				break;
			end
		end
		self.characterName=characterName;

	end

	self.SaveData=function()
		PatchDataSave( Turbine.DataScope.Server, "AltInventory_QuestLog",QuestLog);
	end

	self.RemoveCallbacks=function()
		RemoveCallback(Turbine.Chat,"Received",self.ChatHandler);
	end
	self.RemoveCharacter=function(characterName)
		QuestLog[characterName]=nil;
	end

	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		self.VScroll:SetLeft(newWidth-12);
		self.VScroll:SetHeight(newHeight);
		self.VP:SetWidth(newWidth-12);
		if self.VScroll:GetValue()>self.VScroll:GetMaximum() then
			self.VSCroll:SetValue(self.VSCroll:GetMaximum());
		end
		if self:GetHeight()<self.VP:GetHeight() then
			self.VScroll:SetMaximum(self.VP:GetHeight()-self:GetHeight());
			self.VP:SetTop(-self.VScroll:GetValue());
			self.VScroll:SetVisible(true);
		else
			self.VScroll:SetValue(0);
			self.VScroll:SetVisible(false);
		end
	end
	self.SetLanguage=function()
	end
	self.SetTrimColor=function()
	end
	self.SetBackgroundColor=function()
		self.VP:SetBackColor(backColor);
	end
	self.SetListTextColor=function()
	end
	self.SetFontColor=function()
	end
	self.SetHeadingsColor=function()
	end

-- add a chat listener on Quest messages for the form of:

	local newQuestPattern,completedQuestPattern;
	if locale=="en" then
--		newQuestPattern="Your standing with (.*) is now (.*)%..*";
--		completedQuestPattern="Your standing with (.*) is now (.*)%..*";
	elseif locale=="fr" then
--		newQuestPattern="Your standing with (.*) is now (.*)%..*";
--		completedQuestPattern="Your standing with (.*) is now (.*)%..*";
	else
--		newQuestPattern="Your standing with (.*) is now (.*)%..*";
--		completedQuestPattern="Your standing with (.*) is now (.*)%..*";
	end
	self.ChatHandler=function(sender,args)
		if args.ChatType==Turbine.ChatType.Quest or args.ChatType==Turbine.ChatType.Standard then
--
--			local faction,tier=string.match(args.Message,advancementPattern);
--			if faction~=nil then
--				-- whooohooo! we got a faction advancement message!
--				-- gonna be hard to test this one :(  perhaps create a new character for each test and use up the rep items in the shared vault
--				local tmpIndex,factionID,tierID;
--				for tmpIndex=1,#Faction do
--					if Faction[tmpIndex][2]==faction then
--						factionID=Faction[tmpIndex][1];
--						break;
--					end
--				end
--				if factionID~=nil then
--					for tmpIndex=1,#FactionTier[Faction[factionID][4]] do
--						if FactionTier[Faction[factionID][4]][tmpIndex]==tier then
--							tierID=tmpIndex;
--							break;
--						end
--					end
--					if tierID~=nil then
--						FactionRep[currentCharacterName]["Rep"][factionID]=tierID
--						if self.characterName==currentCharacterName then
--							self:LoadPanelData(currentCharacterName)
--						end
--					end
--				end
--			end
--
		end
	end
	AddCallback(Turbine.Chat,"Received",self.ChatHandler);
end
