-- SharedStorage Panel

-- need to make drag/drop operations drop the item into the correct chest
-- how to allow drag/drop to a chest that has no items?

-- need to figure out the Category sort order to match the "Auto" sort

euroFormat=(tonumber("1,000")==1); -- redundant but harmless

sharedIndexSort=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) elseif (arg1[16]==arg2[16])and(arg1[1]<arg2[1]) then return(true) end end;
sharedNameSort=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) elseif (arg1[16]==arg2[16]) then if (arg1[5]<arg2[5]) then return(true) elseif arg1[5]==arg2[5] then if arg1[6]<arg2[6] then return(true) elseif arg1[6]==arg2[6] and arg1[1]<arg2[1] then return(true) end end end end;
sharedNameSortRev=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) elseif (arg1[16]==arg2[16]) then if (arg1[5]>arg2[5]) then return(true) elseif arg1[5]==arg2[5] then if arg1[6]<arg2[6] then return(true) elseif arg1[6]==arg2[6] and arg1[1]<arg2[1] then return(true) end end end end;
sharedCategorySort=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) else if (arg1[16]==arg2[16]) then if (categorySortOrder[arg1[13]]<categorySortOrder[arg2[13]]) then return(true) elseif (arg1[13]==arg2[13] and arg1[5]<arg2[5]) then return (true) elseif (arg1[13]==arg2[13] and arg1[5]==arg2[5] and arg1[6]<arg2[6]) then return (true) elseif (arg1[13]==arg2[13] and arg1[5]==arg2[5] and arg1[6]==arg2[6] and arg1[1]<arg2[1]) then return (true) end end end end;
sharedQualitySort=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) else if (arg1[16]==arg2[16]) then if (qualitySortOrder[(arg1[3]+1)]<qualitySortOrder[(arg2[3]+1)]) then return(true) elseif (arg1[3]==arg2[3] and arg1[5]<arg2[5]) then return (true) elseif (arg1[3]==arg2[3] and arg1[5]==arg2[5] and arg1[6]<arg2[6]) then return (true) elseif (arg1[3]==arg2[3] and arg1[5]==arg2[5] and arg1[6]==arg2[6] and arg1[1]<arg2[1]) then return (true) end end end end;
sharedWearStateSort=function(arg1,arg2) if (arg1[16]<arg2[16]) then return(true) else if (arg1[16]==arg2[16]) then if (wearStateSortOrder[(arg1[4]+1)]<wearStateSortOrder[(arg2[4]+1)]) then return(true) elseif (arg1[4]==arg2[4] and arg1[5]<arg2[5]) then return (true) elseif (arg1[4]==arg2[4] and arg1[5]==arg2[5] and arg1[6]<arg2[6]) then return (true) elseif (arg1[4]==arg2[4] and arg1[5]==arg2[5] and arg1[6]==arg2[6] and arg1[1]<arg2[1]) then return (true) end end end end;

function LoadData()
	-- load saved settings
	SharedStorageData=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_SharedStorage");
	if SharedStorageData==nil then
		SharedStorageData={};
		SharedStorageData.Filled=0;
		SharedStorageData.Capacity=0;
		SharedStorageData.ChestCount=0;
		SharedStorageData.ChestName={};
	end
	SharedStorageData.VERSION=nil;
end
LoadData()

sharedStorage=localPlayer:GetSharedStorage();

SharedStoragePanel=class(Turbine.UI.Control)
function SharedStoragePanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackground("GaranStuff/AltInventory/Resources/background_mid.jpg");
	self:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self:SetSize(200,200);
	self.characterIndex=1;
	self.View=2;
	self.DefaultSort=2;
	self.TrackMenu=Turbine.UI.ContextMenu()
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][42]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][43]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem("------------------------------------------------------"));
	self.TrackMenu:GetItems():Get(3):SetEnabled(false);
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][44]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][45]));

	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;

-- create panel controls
	self.FilterCaption=Turbine.UI.Label();
	self.FilterCaption:SetParent(self);
	self.FilterCaption:SetPosition(9,6);
	self.FilterCaption:SetSize(70,20);
	self.FilterCaption:SetFont(fontFace);
	self.FilterCaption:SetForeColor(fontColor);
	self.FilterCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.FilterCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.FilterCaption:SetText(Resource[language][24]..":");

	self.FilterList=GaranStuff.AltInventory.DropDownList();
	self.FilterList:SetParent(self);
	self.FilterList:SetPosition(self.FilterCaption:GetLeft()+self.FilterCaption:GetWidth()+3,self.FilterCaption:GetTop()-3);
	self.FilterList:SetSize(self:GetWidth()-(self.FilterCaption:GetWidth()+self.FilterCaption:GetLeft())-40,20);
	self.FilterList:SetBorderColor(trimColor);
	self.FilterList:SetCurrentBackColor(colorDarkGrey);
	self.FilterList:SetBackColor(backColor);
	self.FilterList:SetTextColor(listTextColor);
	self.FilterList:SetCurrentBackColor(backColor);
	self.FilterList:SetDropRows(6);

	self.SearchCaption=Turbine.UI.Label();
	self.SearchCaption:SetParent(self);
	self.SearchCaption:SetPosition(9,31);
	self.SearchCaption:SetSize(70,20);
	self.SearchCaption:SetFont(fontFace);
	self.SearchCaption:SetForeColor(fontColor);
	self.SearchCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SearchCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SearchCaption:SetText(Resource[language][25]..":");

	self.SearchBorder=Turbine.UI.Control();
	self.SearchBorder:SetParent(self);
	self.SearchBorder:SetPosition(self.SearchCaption:GetLeft()+self.SearchCaption:GetWidth()+2,self.SearchCaption:GetTop()-5);
	self.SearchBorder:SetSize(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft()),20);
	self.SearchBorder:SetBackColor(Turbine.UI.Color(.15,.25,.45))

	self.SearchText=Turbine.UI.Lotro.TextBox();
	self.SearchText:SetParent(self);
	self.SearchText:SetPosition(self.SearchCaption:GetLeft()+self.SearchCaption:GetWidth()+3,self.SearchCaption:GetTop()-4);
	self.SearchText:SetSize(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft())-2,18);
	self.SearchText:SetBackColor(Turbine.UI.Color(.25,.35,.55));
	self.SearchText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.SearchText:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SearchText:SetForeColor(fontColor);
	self.SearchText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SearchText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SearchText:SetWantsUpdates(false);
	self.SearchText.Text="";
	self.SearchText.FocusGained=function()
		self.SearchText:SetWantsUpdates(true);
	end
	self.SearchText.FocusLost=function()
		self.SearchText:SetWantsUpdates(false);
	end
	self.SearchText.Update=function()
		if self.SearchText.Text~=self.SearchText:GetText() then
			self.SearchText.Text=self.SearchText:GetText()
			self:LoadPanelData(inventoryWindow.CharacterList:GetText());
		end
	end

	self.ShowAllButton=Turbine.UI.Lotro.Button();
	self.ShowAllButton:SetParent(self);
	self.ShowAllButton:SetSize(120,18);
	self.ShowAllButton:SetPosition(self.FilterList:GetLeft()+self.FilterList:GetWidth()-self.ShowAllButton:GetWidth(),self.SearchText:GetTop()-1);
	self.ShowAllButton:SetText(Resource[language][26]);
	self.ShowAllButton.Click=function()
		self.SearchText:SetWantsUpdates(false);
		self.SearchText:SetText("");
		self.FilterList:SetSelectedIndex(1);
		self.FilterList:SelectedIndexChanged(); -- ideally this would fire on it's own, gotta track down a bug in the dropdown list :(
	end

	self.SortCaption=Turbine.UI.Label();
	self.SortCaption:SetParent(self);
	self.SortCaption:SetPosition(9,54);
	self.SortCaption:SetSize(70,20);
	self.SortCaption:SetFont(fontFace);
	self.SortCaption:SetForeColor(fontColor);
	self.SortCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SortCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SortCaption:SetText(Resource[language][27]..":");

	self.SortList=DropDownList();
	self.SortList:SetParent(self);
	self.SortList:SetPosition(self.SortCaption:GetLeft()+self.SortCaption:GetWidth()+3,self.SortCaption:GetTop()-3);
	self.SortList:SetSize(self:GetWidth()/2-(self.SortCaption:GetWidth()+self.SortCaption:GetLeft())-1,20);
	self.SortList:SetBorderColor(trimColor);
	self.SortList:SetCurrentBackColor(colorDarkGrey);
	self.SortList:SetBackColor(backColor);
	self.SortList:SetTextColor(listTextColor);
	self.SortList:SetCurrentBackColor(backColor);
	self.SortList:SetDropRows(5);  -- increase as we implement the last 2 options

	self.SortList:AddItem(Resource[language][345],0);
	self.SortList:AddItem(Resource[language][31],1);
	self.SortList:AddItem(Resource[language][32],2);
	self.SortList:AddItem(Resource[language][251],3);
	self.SortList:AddItem(Resource[language][33],4);
	self.SortList:AddItem(Resource[language][34],5); -- did this really serve any use other than a mildly interesting programming exercise?  nope.

	self.DisplayCaption=Turbine.UI.Label();
	self.DisplayCaption:SetParent(self);
	self.DisplayCaption:SetPosition(self:GetWidth()/2+10,54);
	self.DisplayCaption:SetSize(70,20);
	self.DisplayCaption:SetFont(fontFace);
	self.DisplayCaption:SetForeColor(fontColor);
	self.DisplayCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.DisplayCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.DisplayCaption:SetText(Resource[language][28]..":");

	self.DisplayMode1=Turbine.UI.Control();
	self.DisplayMode1:SetParent(self);
	self.DisplayMode1:SetPosition(self.DisplayCaption:GetLeft()+self.DisplayCaption:GetWidth()+10,52);
	self.DisplayMode1:SetSize(19,19);
	self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
	self.DisplayMode1.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		self.View=1;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then self:LoadPanelData(inventoryWindow.CharacterList:GetText()) end;
	end

	self.DisplayMode2=Turbine.UI.Control();
	self.DisplayMode2:SetParent(self);
	self.DisplayMode2:SetPosition(self.DisplayMode1:GetLeft()+self.DisplayMode1:GetWidth()+10,52);
	self.DisplayMode2:SetSize(19,19);
	self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
	self.DisplayMode2.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		self.View=2;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then self:LoadPanelData(inventoryWindow.CharacterList:GetText()) end;
	end

	self.DisplayMode3=Turbine.UI.Control();
	self.DisplayMode3:SetParent(self);
	self.DisplayMode3:SetPosition(self.DisplayMode2:GetLeft()+self.DisplayMode2:GetWidth()+10,52);
	self.DisplayMode3:SetSize(19,19);
	self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
	self.DisplayMode3.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
		self.View=3;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then self:LoadPanelData(inventoryWindow.CharacterList:GetText()) end;
	end

	self.SortList.SelectedIndexChanged = function ()
		-- reload the display (since displaying the inventory automatically applies the current sort)
		self:LoadPanelData(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
	end

	self:SetVisible(false);

	self.IsValid=function()
		return (characterListArray[self.characterIndex][9]==nil or characterListArray[self.characterIndex][9]==Turbine.Gameplay.Alignment.FreePeople);
	end
	self.ItemCol={};
	self.QtyCol={};
	self.ItemControl={};
	self.ItemIcon={};
	self.SeparatorCol={};
	self.LoadPanelData=function(sender, characterName)
if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
		local tmpIndex;
		for tmpIndex=1,#characterListArray do
			if characterListArray[tmpIndex][1]==characterName then
				self.characterIndex=tmpIndex;
				if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
					self:SetVisible(self:IsValid())
				end
				break;
			end
		end
		-- for Shared Storage, ALL characters share the same storage so it doesn't matter what character is currently selected
		self.InventoryListBackground.InventoryList:SetAllowDrop( true );

		local filterIndex;

		for filterIndex=2,self.FilterList.ListData:GetItemCount() do
			self.FilterList:HideEntry(filterIndex);
		end
		local listIndex;
		for listIndex=1,#self.ItemCol do
			self.ItemCol[listIndex].MouseEnter=nil
			self.ItemCol[listIndex].Update=nil
			self.ItemCol[listIndex].MouseLeave=nil
			self.ItemCol[listIndex].MouseClick=nil
			self.QtyCol[listIndex].MouseClick=nil
			self.QtyCol[listIndex].MouseEnter=nil
			self.QtyCol[listIndex].Update=nil
			self.QtyCol[listIndex].MouseLeave=nil
		end
		for listIndex=1,self.InventoryListBackground.InventoryList:GetItemCount() do
			-- first thing we need to do is unregister the old event handlers, since they don't automatically go away when they item does
			if self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol~=nil and self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol.GetItem~=nil then
				-- it's an item control that has an item
				RemoveCallback(self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol:GetItem(),"QuantityChanged",self.refreshStorage)
				RemoveCallback(self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol:GetItem(),"ChestChanged",self.chestChanged)
			end
			self.InventoryListBackground.InventoryList:GetItem(listIndex):SetHeight(0);
		end
		local tmpQuality=0;
		local tmpIndex;
		if (#SharedStorageData>0) then
			-- apply the current sort
			if (self.SortList:GetValue()==0) then
				-- sort on chest Index
				table.sort(SharedStorageData,sharedIndexSort);
			elseif (self.SortList:GetValue()==1) then
				-- sort on Name A-Z
				table.sort(SharedStorageData,sharedNameSort);
			elseif (self.SortList:GetValue()==2) then
				-- sort on Name Z-A
				table.sort(SharedStorageData,sharedNameSortRev);
			elseif (self.SortList:GetValue()==3) then
				-- sort on Category
				-- we have to be careful that the category exists since there are holes in the enumeration. if it doesn't exist, assign it the same order as "Undefined"
				for tmpIndex=1,#SharedStorageData do
					if categorySortOrder[SharedStorageData[tmpIndex][13]]==nil then
					-- set it to the same sort order as the Undefined category
						categorySortOrder[SharedStorageData[tmpIndex][13]]=categorySortOrder[Turbine.Gameplay.ItemCategory.Undefined];
					end
				end
				table.sort(SharedStorageData,sharedCategorySort);
			elseif (self.SortList:GetValue()==4) then
				-- sort on Quality
				table.sort(SharedStorageData,sharedQualitySort);
			elseif (self.SortList:GetValue()==5) then
				-- sort on WearState  wearStateSortOrder
				table.sort(SharedStorageData,sharedWearStateSort);
			end
		end

		local displayCol=0;
		local displayRow=1;
		local separatorIndex=1;
		local newRow=true;
		local elementWidth;
		if self.View==1 then
			elementWidth=399;
		elseif self.View==2 then
			elementWidth=193;
		else
			elementWidth=34;
		end
		local maxCols=math.floor((self.InventoryListBackground:GetWidth()-17)/(elementWidth+1));
		for index=1,#self.ItemControl do
			self.ItemControl[index]:SetSize(0,0);
			if self.ItemControl[index]:GetItem()~=nil and self.ItemControl[index]:GetItem().QuantityChanged~=nil then
				RemoveCallback(self.ItemControl[index]:GetItem(),"QuantityChanged",self.refreshStorage);
				RemoveCallback(self.ItemControl[index]:GetItem(),"ChestChanged",self.chestChanged);
			end
		end
		for index=1,#self.ItemIcon do
			self.ItemIcon[index]:SetSize(0,0);
			self.ItemCol[index]:SetSize(0,0);
			self.QtyCol[index]:SetSize(0,0);
		end
		for index=1,#self.SeparatorCol do
			self.SeparatorCol[index]:SetSize(0,0);
		end
		local currentChest=-1;
		for index=1,#SharedStorageData do
			local showUndefined=true;
			for filterIndex=2,self.FilterList.ListData:GetItemCount() do
				if SharedStorageData[index][5]~="" and SharedStorageData[index][13]~=nil and SharedStorageData[index][13]==self.FilterList.ListData:GetItem(filterIndex).DataValue then
					self.FilterList:ShowEntry(filterIndex);
					showUndefined=false;
					break;
				end
			end

			if showUndefined and SharedStorageData[index][5]~="" then
				-- the item category was not found, show the Undefined entry
				if debug then
					Turbine.Shell.WriteLine("Item with unrecognized Category code:"..tostring(SharedStorageData[index][13])..", "..SharedStorageData[index][5]);
				end
				self.FilterList:ShowEntry(undefinedCategoryIndex);
			end

			if index>#self.ItemControl then
				self.ItemControl[index]=Turbine.UI.Lotro.ItemControl();
				self.ItemControl[index]:SetBackColor(self.InventoryListBackground:GetBackColor());
			end
			if index>#self.ItemIcon then
				self.ItemIcon[index]=Turbine.UI.Control();
				self.ItemIcon[index]:SetOpacity(1);
				self.ItemIcon[index].IconImage=Turbine.UI.Control();
				self.ItemIcon[index].IconImage:SetParent(self.ItemIcon[index]);
				self.ItemIcon[index].IconImage:SetBlendMode(Turbine.UI.BlendMode.Overlay);
				self.ItemIcon[index].IconImage:SetSize(32,32);
				self.ItemIcon[index].IconImage:SetPosition(0,0);
				self.ItemIcon[index].QtyText=Turbine.UI.Label();
				self.ItemIcon[index].QtyText:SetParent(self.ItemIcon[index]);
				self.ItemIcon[index].QtyText:SetFontStyle(Turbine.UI.FontStyle.Outline);
				self.ItemIcon[index].QtyText:SetTextAlignment( Turbine.UI.ContentAlignment.BottomRight );
				self.ItemCol[index]=Turbine.UI.Label();
				self.ItemCol[index]:SetParent(tmpRow);
				self.ItemCol[index]:SetLeft(44);
				self.ItemCol[index]:SetMultiline(false);
				self.ItemCol[index]:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-53,17);
				self.ItemCol[index]:SetBackColor(Turbine.UI.Color(.05,.07,.09));
				self.ItemCol[index]:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
				self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
				self.QtyCol[index]=Turbine.UI.Label();
				self.QtyCol[index]:SetParent(tmpRow);
				self.QtyCol[index]:SetSize(0,17);
				self.QtyCol[index]:SetLeft(0);
				self.QtyCol[index]:SetBackColor(Turbine.UI.Color(.05,.07,.09));
				self.QtyCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
			end

			local tmpRow;

--			if (self.SortList:GetValue()==0) and SharedStorageData[index][16]~=currentChest then
			if SharedStorageData[index][16]~=currentChest then
				-- display separator for all chests from currentChest+1 to SharedStorageData[index][16]
				for tmpChest=currentChest+1, SharedStorageData[index][16] do
					if displayCol>0 then
						displayRow=displayRow+1;
					end
					-- insert a Chest Separator when the Chest # changes
					if displayRow<=self.InventoryListBackground.InventoryList:GetItemCount() then 
						tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
					else
						tmpRow=Turbine.UI.Control();
						tmpRow:SetLeft(1);
						self.InventoryListBackground.InventoryList:AddItem(tmpRow);
					end
					tmpRow:SetBackColor(self.InventoryListBackground:GetBackColor());
					tmpRow:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-2,20);
					if separatorIndex>#self.SeparatorCol then
						self.SeparatorCol[separatorIndex]=Turbine.UI.Label();
					end
					self.SeparatorCol[separatorIndex]:SetParent(tmpRow);
					self.SeparatorCol[separatorIndex]:SetFont(fontFace);
					self.SeparatorCol[separatorIndex]:SetForeColor(fontColor);
					self.SeparatorCol[separatorIndex]:SetSize(tmpRow:GetWidth(),20)
					self.SeparatorCol[separatorIndex]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
					self.SeparatorCol[separatorIndex]:SetText(SharedStorageData.ChestName[tmpChest]);
					separatorIndex=separatorIndex+1;
					newRow=true;
					displayCol=0;
					displayRow=displayRow+1;
				end
				currentChest=SharedStorageData[index][16];
			end

			if self.View==3 then
				if not(SharedStorageData[index][5]==nil or SharedStorageData[index][5]=="") then
					if (self.FilterList:GetValue()==-1 or (SharedStorageData[index][13]~=nil and SharedStorageData[index][13]==self.FilterList:GetValue()) or (self.FilterList:GetValue()==Turbine.Gameplay.ItemCategory.Undefined and showUndefined==true)) and (self.SearchText:GetText()=="" or string.find(string.lower(tostring(SharedStorageData[index][5])),string.lower(self.SearchText:GetText()),nil,true)~=nil ) then
						if newRow then
							newRow=false;
							if displayRow<=self.InventoryListBackground.InventoryList:GetItemCount() then 
								tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
							else
								tmpRow=Turbine.UI.Control();
								tmpRow:SetLeft(1);
								self.InventoryListBackground.InventoryList:AddItem(tmpRow);
							end
							tmpRow:SetBackColor(self.InventoryListBackground:GetBackColor());
						else
							tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
						end
						tmpRow:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-2,34);
						self.ItemControl[index]:SetParent(tmpRow);
--						self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)-1,-3);-- there is a bug in the item control that renders vault items without border
						self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)+2,0);
						self.ItemIcon[index]:SetParent(tmpRow);
						self.ItemIcon[index]:SetPosition((elementWidth+1)*(displayCol)+2,0);
						self.ItemCol[index]:SetParent(tmpRow);
						self.QtyCol[index]:SetParent(tmpRow);
						if sharedStorage:IsAvailable() then
							self.ItemControl[index]:SetSize(35,35);
							local tmpItem=sharedStorage:GetItem(SharedStorageData[index][1])
							if tmpItem~=nil then
								AddCallback(tmpItem,"QuantityChanged",self.refreshStorage);
								AddCallback(tmpItem,"ChestChanged",self.chestChanged);
							end
							self.ItemControl[index]:SetItem(nil); -- set to nil to clear the cached info in the control otherwise it can display the wrong qty
							self.ItemControl[index]:SetItem(tmpItem);
							self.ItemIcon[index]:SetSize(0,0);
						else
							if SharedStorageData[index][8]~=nil and SharedStorageData[index][8]~=0 then
								-- create the icon image...
								self.ItemIcon[index]:SetSize(32,32);
								self.ItemIcon[index]:SetBackground(SharedStorageData[index][8]);
								self.ItemIcon[index].IconImage:SetBackground(SharedStorageData[index][9]);
								self.ItemIcon[index].QtyText:SetText("");
								if SharedStorageData[index][6]~=nil and SharedStorageData[index][6]>1 then
									self.ItemIcon[index].QtyText:SetSize(32,27);
									self.ItemIcon[index].QtyText:SetPosition(0,0);
									if SharedStorageData[index][6]<10000 then
										self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
									else
										self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
									end
									self.ItemIcon[index].QtyText:SetText(SharedStorageData[index][6].." ");
								end
							end
							self.ItemControl[index]:SetItem(nil);
							self.ItemControl[index]:SetSize(0,0);
						end

						displayCol=displayCol+1;
						if displayCol>=maxCols then
							newRow=true;
							displayCol=0;
							displayRow=displayRow+1;
						end
					end
				else
					-- we need to hide the prior view of this item index
					self.ItemControl[index]:SetItem(nil);
					self.ItemControl[index]:SetSize(0,0);
				end
			else
				-- view=1 or 2
				if not(SharedStorageData[index][5]==nil or SharedStorageData[index][5]=="") then
					if (self.FilterList:GetValue()==-1 or (SharedStorageData[index][13]~=nil and SharedStorageData[index][13]==self.FilterList:GetValue()) or (self.FilterList:GetValue()==Turbine.Gameplay.ItemCategory.Undefined and showUndefined==true)) and (self.SearchText:GetText()=="" or string.find(string.lower(tostring(SharedStorageData[index][5])),string.lower(self.SearchText:GetText()),1,true)~=nil ) then
						if newRow then
							newRow=false;
							if displayRow<=self.InventoryListBackground.InventoryList:GetItemCount() then 
								tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
							else
								tmpRow=Turbine.UI.Control();
								tmpRow:SetLeft(1);
								self.InventoryListBackground.InventoryList:AddItem(tmpRow);
							end
						else
							tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
						end
						self.ItemCol[index]:SetParent(tmpRow);
						self.QtyCol[index]:SetParent(tmpRow);
						if self.View==1 then
							self.ItemCol[index]:SetMultiline(false);
							self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
							self.QtyCol[index]:SetSize(40,17);
							self.QtyCol[index]:SetLeft((elementWidth+1)*(displayCol))
							self.ItemCol[index]:SetLeft((elementWidth+1)*(displayCol)+42);
							self.ItemCol[index]:SetSize(elementWidth-42,17);
							tmpRow:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-2,18);
						else
							self.ItemCol[index]:SetMultiline(true);
							self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft);
							self.QtyCol[index]:SetSize(0,17);
							self.QtyCol[index]:SetLeft((elementWidth+1)*(displayCol))
							self.ItemCol[index]:SetLeft((elementWidth+1)*(displayCol)+36);
							self.ItemCol[index]:SetSize(elementWidth-33,31);
							tmpRow:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-2,34);
						end
						tmpRow:SetBackColor(self.InventoryListBackground:GetBackColor());

						self.ItemControl[index]:SetParent(tmpRow);
						self.ItemControl[index]:SetSize(0,0);
--						self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)-1,-2); -- item control is bugged for shared storage items
						self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)+2,0);
						self.ItemIcon[index]:SetParent(tmpRow);
						self.ItemIcon[index]:SetSize(0,0);
						self.ItemIcon[index]:SetPosition((elementWidth+1)*(displayCol)+2,0);

						if sharedStorage:IsAvailable() then
							local tmpItem=sharedStorage:GetItem(SharedStorageData[index][1])
							if tmpItem~=nil then
								AddCallback(tmpItem,"QuantityChanged",self.refreshStorage);
								AddCallback(tmpItem,"ChestChanged",self.chestChanged);
							end
							self.ItemControl[index]:SetItem(nil); -- set to nil to clear the cached info in the control otherwise it can display the wrong qty
							self.ItemControl[index]:SetItem(tmpItem);
							if self.View==2 then
								self.ItemControl[index]:SetSize(35,35);
							end
						end
	
						self.ItemCol[index]:SetText("");
						self.QtyCol[index]:SetText("");
						if sharedStorage:IsAvailable()==false and SharedStorageData[index][8]~=nil and SharedStorageData[index][8]~=0 and self.View==2 then
							-- create the icon image...
							self.ItemIcon[index]:SetSize(32,32);
							self.ItemIcon[index]:SetBackground(SharedStorageData[index][8]);
							self.ItemIcon[index].IconImage:SetBackground(SharedStorageData[index][9]);
							self.ItemIcon[index].QtyText:SetText("");
							if SharedStorageData[index][6]~=nil and SharedStorageData[index][6]>1 then
								self.ItemIcon[index].QtyText:SetSize(32,27);
								self.ItemIcon[index].QtyText:SetPosition(0,0);
								if SharedStorageData[index][6]<10000 then
									self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
								else
									self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
								end
								self.ItemIcon[index].QtyText:SetText(SharedStorageData[index][6].." ");
							end
						end
						self.ItemCol[index]:SetText(SharedStorageData[index][5]);
						if SharedStorageData[index][3]~=nil then
							tmpQuality=tonumber(SharedStorageData[index][3]);
						else
							tmpQuality=0;
						end
						if SharedStorageData[index][6]~=nil and SharedStorageData[index][6]~=0 then
							self.QtyCol[index]:SetText(SharedStorageData[index][6]);
						else
							self.QtyCol[index]:SetText("");
						end
						if tmpQuality==Turbine.Gameplay.ItemQuality.Common then
							self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.95,.95,.95));
						elseif tmpQuality==Turbine.Gameplay.ItemQuality.Incomparable then
							self.ItemCol[index]:SetForeColor(Turbine.UI.Color(0,.8,.75));
						elseif tmpQuality==Turbine.Gameplay.ItemQuality.Legendary then
							self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.8,.5,.2));
						elseif tmpQuality==Turbine.Gameplay.ItemQuality.Rare then
							self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.75,0,.75));
						elseif tmpQuality==Turbine.Gameplay.ItemQuality.Uncommon then
							self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.75,.85,.1));
						end
						self.ItemCol[index].MouseClick=function(sender,args)
							if args.Button==2 then
								self.TrackMenu:GetItems():Get(1):SetEnabled(trackWindow:CharListIndexOf(SharedStorageData[index][5])==0);
								self.TrackMenu:GetItems():Get(2):SetEnabled(not self.TrackMenu:GetItems():Get(1):IsEnabled());
								self.TrackMenu:GetItems():Get(4):SetEnabled(trackWindow:AllListIndexOf(SharedStorageData[index][5])==0);
								self.TrackMenu:GetItems():Get(5):SetEnabled(not self.TrackMenu:GetItems():Get(4):IsEnabled());
								self.TrackMenu:GetItems():Get(1).Click=function()
									trackWindow:CharAddItem(SharedStorageData[index][5]);
								end
								self.TrackMenu:GetItems():Get(2).Click=function()
									trackWindow:CharRemoveItem(SharedStorageData[index][5]);
								end
								self.TrackMenu:GetItems():Get(4).Click=function()
									trackWindow:AllAddItem(SharedStorageData[index][5]);
								end
								self.TrackMenu:GetItems():Get(5).Click=function()
									trackWindow:AllRemoveItem(SharedStorageData[index][5]);
								end
								self.TrackMenu:ShowMenu()
							end
						end
						displayCol=displayCol+1;
						if displayCol>=maxCols then
							newRow=true;
							displayCol=0;
							displayRow=displayRow+1;
						end
					end
				end
			end -- {if self.View==3}
		end -- end for index=1,#SharedStorageData do
--**********************************************
-- need to show chest separators for all chests from currentChest+1 to maxchest
		-- display separator for all chests from currentChest+1 to SharedStorageData[index][16]
		for tmpChest=currentChest+1, SharedStorageData.ChestCount-1 do
			if displayCol>0 then
				displayRow=displayRow+1;
			end
			-- insert a Chest Separator when the Chest # changes
			if displayRow<=self.InventoryListBackground.InventoryList:GetItemCount() then 
				tmpRow=self.InventoryListBackground.InventoryList:GetItem(displayRow);
			else
				tmpRow=Turbine.UI.Control();
				tmpRow:SetLeft(1);
				self.InventoryListBackground.InventoryList:AddItem(tmpRow);
			end
			tmpRow:SetBackColor(self.InventoryListBackground:GetBackColor());
			tmpRow:SetSize(self.InventoryListBackground.InventoryList:GetWidth()-2,20);
			if separatorIndex>#self.SeparatorCol then
				self.SeparatorCol[separatorIndex]=Turbine.UI.Label();
			end
			self.SeparatorCol[separatorIndex]:SetParent(tmpRow);
			self.SeparatorCol[separatorIndex]:SetFont(fontFace);
			self.SeparatorCol[separatorIndex]:SetForeColor(fontColor);
			self.SeparatorCol[separatorIndex]:SetSize(tmpRow:GetWidth(),20)
			self.SeparatorCol[separatorIndex]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
			self.SeparatorCol[separatorIndex]:SetText(SharedStorageData.ChestName[tmpChest]);
--			self.SeparatorCol[separatorIndex]:SetText(tmpChest);
			separatorIndex=separatorIndex+1;
			newRow=true;
			displayCol=0;
			displayRow=displayRow+1;
		end
--**********************************************
		self.InventoryListBackground.InventoryList:SetVerticalScrollBar(self.InventoryListBackground.InventoryList.VScrollBar)
		if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
			local filled=SharedStorageData.Filled;
			local capacity=SharedStorageData.Capacity;
			inventoryWindow.SharedCapacityPanel.Display:SetText(Resource[language][347].." ("..filled.."/"..capacity..")")
			inventoryWindow.SharedCapacityPanel:SetSize(inventoryWindow.SharedCapacityPanel.MaxWidth*(filled/capacity),17);
			inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(0,.3,0))
			if (filled/capacity)>=.75 then
				inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(.3,0,0))
			elseif (filled/capacity)>=.5 then
				inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(.75,.65,0))
			end
			inventoryWindow.SharedCapacityPanel:SetVisible(true);
		end
end
	end

	self.Activated=function(sender)
		if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
			inventoryWindow.BagCapacityPanel:SetVisible(false);
			inventoryWindow.BagCapacityPanel.Empty:SetVisible(false);
			inventoryWindow.BagCapacityPanel.Display:SetVisible(false);
			inventoryWindow.BagCapacityPanel.Full:SetVisible(false);
			inventoryWindow.VaultCapacityPanel:SetVisible(false);
			inventoryWindow.VaultCapacityPanel.Empty:SetVisible(false);
			inventoryWindow.VaultCapacityPanel.Display:SetVisible(false);
			inventoryWindow.VaultCapacityPanel.Full:SetVisible(false);
			inventoryWindow.SharedCapacityPanel:SetVisible(true);
			inventoryWindow.SharedCapacityPanel.Empty:SetVisible(true);
			inventoryWindow.SharedCapacityPanel.Display:SetVisible(true);
			inventoryWindow.SharedCapacityPanel.Full:SetVisible(true);

			local filled=SharedStorageData.Filled;
			local capacity=SharedStorageData.Capacity;
			inventoryWindow.SharedCapacityPanel.Display:SetText(Resource[language][347].." ("..filled.."/"..capacity..")")
			inventoryWindow.SharedCapacityPanel:SetSize(inventoryWindow.SharedCapacityPanel.MaxWidth*(filled/capacity),17);
			inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(0,.3,0))
			if (filled/capacity)>=.75 then
				inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(.3,0,0))
			elseif (filled/capacity)>=.5 then
				inventoryWindow.SharedCapacityPanel:SetBackColor(Turbine.UI.Color(.75,.65,0))
			end
		end
	end
	self.refreshStorage=function()
		if sharedStorage:IsAvailable() then
			-- refresh the SharedStorageData table
			local size=sharedStorage:GetCount();
			if size==0 then
				self:SetWantsUpdates(true);
				-- when first accessed, the size can be 0 if the data isn't really available
				-- the update handler will asynchronously catch the data when it actually becomes available
			else
				SharedStorageData={}; -- just rebuild the array from scratch
				local tmpIndex,tmpItem;
				for tmpIndex=1,size do
					tmpItem=sharedStorage:GetItem(tmpIndex);
					local itemInfo=tmpItem:GetItemInfo();
					SharedStorageData[tmpIndex]= {tmpIndex,itemInfo:GetDurability(),itemInfo:GetQuality(),tmpItem:GetWearState(),itemInfo:GetName(),tmpItem:GetQuantity(),{},itemInfo:GetBackgroundImageID(),itemInfo:GetIconImageID(),itemInfo:GetQualityImageID(),itemInfo:GetShadowImageID(),itemInfo:GetUnderlayImageID(),itemInfo:GetCategory(), itemInfo:IsMagic(), itemInfo:IsUnique(), tmpItem:GetChest()};
				end
				SharedStorageData.Filled=sharedStorage:GetCount();
				SharedStorageData.Capacity=sharedStorage:GetCapacity();
				SharedStorageData.ChestCount=sharedStorage:GetChestCount();
				local tmpChest;
				SharedStorageData.ChestName={};
				for tmpChest=0,SharedStorageData.ChestCount-1 do
					SharedStorageData.ChestName[tmpChest]=sharedStorage:GetChestName(tmpChest);
				end
			end
		end
		if inventoryWindow~=nil and (inventoryWindow:IsVisible() or minimalWindow:IsVisible()) then self:LoadPanelData(inventoryWindow.CharacterList:GetText()) end;
	end
	self.Update=function()
		-- this is a fix for the initialization bug in the Vault and Shared Storage objects
		if sharedStorage:IsAvailable() then
			if sharedStorage:GetCount()>0 then
				self:SetWantsUpdates(false);
				self:refreshStorage();
			end
		else
			self:SetWantsUpdates(false);
		end
	end
	self.itemsRefreshed=function(sender,args)
		self:refreshStorage();
	end
	self.chestChanged=function(sender,args)
		self:refreshStorage();
	end
	self.chestNameChanged=function(sender,args)
		self:refreshStorage();
	end
	self.countChanged=function(sender,args)
		self:refreshStorage();
	end
	self.capacityChanged=function(sender,args)
		self:refreshStorage();
	end

	self:refreshStorage();
	AddCallback(sharedStorage,"IsAvailableChanged",self.refreshStorage);
-- possible useful events .ItemsRefreshed .ChestChanged .ChestNameChanged .CountChanged .CapacityChanged
	AddCallback(sharedStorage,"ItemsRefreshed",self.itemsRefreshed);
	AddCallback(sharedStorage,"ChestNameChanged",self.chestNameChanged);
	AddCallback(sharedStorage,"CountChanged",self.countChanged);
	AddCallback(sharedStorage,"CapacityChanged",self.capacityChanged);

	self.SaveData=function()
		SharedStorageData.VERSION=Plugins["AltInventory"]:GetVersion()
		PatchDataSave( Turbine.DataScope.Server, "AltInventory_SharedStorage",SharedStorageData);
	end

	self.RemoveCallbacks=function()
		self.SearchText.Update=nil;
self.Update=nil;
		RemoveCallback(sharedStorage,"IsAvailableChanged",self.refreshStorage);
		RemoveCallback(sharedStorage,"ItemsRefreshed",self.itemsRefreshed);
		RemoveCallback(sharedStorage,"ChestChanged",self.chestChanged);
		RemoveCallback(sharedStorage,"ChestNameChanged",self.chestNameChanged);
		RemoveCallback(sharedStorage,"CountChanged",self.countChanged);
		RemoveCallback(sharedStorage,"CapacityChanged",self.capacityChanged);
	end
	self.RemoveCharacter=function(characterName)
	end

	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		self.FilterList:SetWidth(newWidth-(self.FilterCaption:GetWidth()+self.FilterCaption:GetLeft())-40);
		self.SearchBorder:SetWidth(newWidth/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft()));
		self.SearchText:SetWidth(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft())-2);
		self.ShowAllButton:SetLeft(self.FilterList:GetLeft()+self.FilterList:GetWidth()-self.ShowAllButton:GetWidth());

		self.SortList:SetSize(self:GetWidth()/2-(self.SortCaption:GetWidth()+self.SortCaption:GetLeft())-1,self.SortList:GetHeight());
		self.DisplayCaption:SetLeft(self:GetWidth()/2+10);
		self.DisplayMode1:SetLeft(self.DisplayCaption:GetLeft()+self.DisplayCaption:GetWidth()+10);
		self.DisplayMode2:SetLeft(self.DisplayMode1:GetLeft()+self.DisplayMode1:GetWidth()+10);
		self.DisplayMode3:SetLeft(self.DisplayMode2:GetLeft()+self.DisplayMode2:GetWidth()+10);
		self.InventoryListBackground:SetHeight(newHeight-79);
		self.InventoryListBackground.InventoryList:SetHeight(self.InventoryListBackground:GetHeight()-2);
		self.InventoryListBackground.InventoryList.VScrollBar:SetHeight(self.InventoryListBackground:GetHeight()-2);
		self.InventoryListBackground:SetWidth(newWidth);
		self.InventoryListBackground.InventoryList:SetWidth(self.InventoryListBackground:GetWidth()-4);
		local tmpIndex;

		for tmpIndex=1,self.InventoryListBackground.InventoryList:GetItemCount() do
			self.InventoryListBackground.InventoryList:GetItem(tmpIndex):SetWidth(self.InventoryListBackground.InventoryList:GetWidth()-2)
		end
		self.InventoryListBackground.InventoryList.VScrollBar:SetLeft(self.InventoryListBackground:GetWidth()-16);

		if inventoryWindow~=nil then self:LoadPanelData(inventoryWindow.CharacterList:GetText()) end;
	end
	self.SetLanguage=function()
	end
	self.SetTrimColor=function()
		self.FilterList:SetBorderColor(trimColor);
		self.SortList:SetBorderColor(trimColor);
	end
	self.SetBackgroundColor=function()
		self.FilterList:SetBackColor(backColor);
		self.FilterList:SetCurrentBackColor(backColor);
		self.SortList:SetBackColor(backColor);
		self.SortList:SetCurrentBackColor(backColor);
		self.InventoryListBackground.InventoryList:SetBackColor(backColor);
		self.InventoryListBackground.InventoryList.VScrollBar:SetBackColor(backColor);
	end
	self.SetListTextColor=function()
		self.FilterList:SetTextColor( listTextColor );
		self.SortList:SetTextColor( listTextColor );
	end
	self.SetView=function(view)
		self.View=view;
		if view==1 then
			self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
		else
			self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		end
		if view==2 then
			self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
		else
			self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		end
		if view==3 then
			self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
		else
			self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		end
	end
	self.SetFontColor=function()
		self.FilterCaption:SetForeColor(fontColor);
		self.SearchCaption:SetForeColor(fontColor);
		self.SearchText:SetForeColor(fontColor);
		self.SortCaption:SetForeColor(fontColor);
		self.DisplayCaption:SetForeColor(fontColor);
	end
	self.SetHeadingsColor=function()
	end
	self.SetEnabled=function(state)
		Turbine.UI.Control.SetEnabled(self,state);
		self.FilterList:SetEnabled(state);
		self.SearchText:SetEnabled(state);
		self.ShowAllButton:SetEnabled(state);
		self.SortList:SetEnabled(state);
		self.DisplayMode1:SetMouseVisible(state);
		self.DisplayMode2:SetMouseVisible(state);
		self.DisplayMode3:SetMouseVisible(state);
		self.InventoryListBackground:SetVisible(state);
	end
	self.InventoryListBackground=Turbine.UI.Control();
	self.InventoryListBackground:SetParent(self);
	self.InventoryListBackground:SetPosition(0,78);
	self.InventoryListBackground:SetSize(self:GetWidth(),self:GetHeight()-263);
	self.InventoryListBackground:SetBackColor(Turbine.UI.Color(0,0,0)); -- this one has to stay fixed for grid to show
	self.InventoryListBackground.InventoryList=Turbine.UI.ListBox();
	self.InventoryListBackground.InventoryList:SetParent(self.InventoryListBackground);
	self.InventoryListBackground.InventoryList:SetPosition(2,1);
	self.InventoryListBackground.InventoryList:SetSize(self.InventoryListBackground:GetWidth()-4,self.InventoryListBackground:GetHeight()-2);
	self.InventoryListBackground.InventoryList:SetBackColor(backColor);
	self.InventoryListBackground.InventoryList.VScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.InventoryListBackground.InventoryList.VScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.InventoryListBackground.InventoryList.VScrollBar:SetParent(self.InventoryListBackground.InventoryList);
	self.InventoryListBackground.InventoryList.VScrollBar:SetBackColor(backColor);
	self.InventoryListBackground.InventoryList.VScrollBar:SetPosition(self.InventoryListBackground:GetWidth()-16,0)
	self.InventoryListBackground.InventoryList.VScrollBar:SetWidth(12);
	self.InventoryListBackground.InventoryList.VScrollBar:SetHeight(self.InventoryListBackground:GetHeight()-2);
	self.InventoryListBackground.InventoryList:SetAllowDrop( false );
	
	self.InventoryListBackground.InventoryList.DragDrop = function( sender, args )
		-- verify that the shared storage object is still available
		if sharedStorage:IsAvailable() then
			local shortcut = args.DragDropInfo:GetShortcut();
			if ( shortcut ~= nil ) then
--Turbine.Shell.WriteLine("shrotcut:GetData="..shortcut:GetData());
			-- for now, we don't care which slot it goes in, just put it in the first slot
				sharedStorage:PerformShortcutDrop( shortcut, 1, Turbine.UI.Control.IsShiftKeyDown() );
			end
		end
	end

	self.InventoryListBackground:SetZOrder(4);
	self.InventoryListBackground.InventoryList:SetZOrder(5);
	self.InventoryListBackground.InventoryList.VScrollBar:SetZOrder(6);

	self.SortCaption:SetZOrder(31);
	self.SortList:SetZOrder(32);
	self.DisplayCaption:SetZOrder(34);
	self.DisplayMode1:SetZOrder(36);
	self.DisplayMode2:SetZOrder(38);
	self.DisplayMode3:SetZOrder(40);
	self.SearchCaption:SetZOrder(42);
	self.SearchBorder:SetZOrder(44);
	self.SearchText:SetZOrder(46);
	self.ShowAllButton:SetZOrder(47);
	self.FilterCaption:SetZOrder(48);
	self.FilterList:SetZOrder(50);

	table.sort(ItemCategory,function(arg1,arg2) return(arg1[3]<arg2[3]) end)

	self.FilterList:AddItem(Resource[language][29],-1);

	for tmpIndex=1,#ItemCategory do
		if ItemCategory[tmpIndex][1]==Turbine.Gameplay.ItemCategory.Undefined then
			undefinedCategoryIndex=tmpIndex+1; -- need to keep track of where the "undefined" category winds up in the list
		end
		categorySortOrder[ItemCategory[tmpIndex][1]]=tmpIndex;
		self.FilterList:AddItem(ItemCategory[tmpIndex][3],ItemCategory[tmpIndex][1]);
	end

	self.FilterList.SelectedIndexChanged = function ()
		self:LoadPanelData(inventoryWindow.CharacterList:GetText());
	end
end
